C
C  *************************************************************************
C    SUBROUTINE NORMZ---CALLED BY MAXLIK DURING UTILITY FUNCTION PHASE.
C       CHECKS FOR SAG IN LEGISLATOR COORDINATES AND CONSTRAINS "SAGGED"
C       LEGISLATORS FROM BEING FURTHER ESTIMATED.  READJUSTS LEGISLATOR
C       COORDINATES TO LIE BETWEEN -1 AND +1.  READJUSTS ROLL CALL OUTCOME
C       COORDINATES SO THAT SUM OF DYN**2 = SUM OF ABS(XI-ZMID)*DYN.
C  *************************************************************************
C
      SUBROUTINE NORMZ
      DIMENSION XD(1000),LMO(1000),XINCU(500),CHALL(500)
      COMMON /XXCOM/ ZMID(1601),XDATA(513),DYN(1601),ldata(501,601),
     CUCUT(501),UINC(501),XINC(1601)
      COMMON /MINE/ NS,NQ,NRCALL,NSTEP,NEQ,ISENS(1000),
     CJAN,JANLST,JIO,KIO,NOBS,NOPAR,IFDRV,NFEVAL,
     CMAXIT,MAXSQZ,KNOL,KSTRT
      COMMON /SENMIN/ sss(100),KSMIN,KSMAX
      COMMON /BOOK/ BBB(50)
 1000 FORMAT(' FURTHEST LEFT SENATOR=',F10.4,2X,
     C'FURTHEST RIGHT SENATOR=',F10.4/14X,'OLD LEFT=',F10.4,
     C15X,'OLD RIGHT=',F10.4/' POSITIONS: LEFT=',I5,3X,'RIGHT=',I5)
 1001 FORMAT('    ADJUSTMENT TO OUTCOME COORDINATES=',2F10.4)
 1002 FORMAT(I6,4f10.4,4I6)
 1111 format(4f10.4)
      DO 3 I=1,NOBS
      XD(I)=XDATA(I)
      LMO(I)=I
  3   CONTINUE
      call RSORT(XD,NOBS,LMO)
C
C  EXAMINE PAC CONFIGURATION FOR SAG.  
C
      DO 99 JJ=1,20
      WRITE(KIO,1002)JJ,XD(JJ),XD(JJ+1),XD(NOBS+1-JJ),
     CXD(NOBS-JJ),ISENS(LMO(JJ)),ISENS(LMO(JJ+1)),
     CISENS(LMO(NOBS+1-JJ)),ISENS(LMO(NOBS-JJ))
      IF(ABS(XD(JJ)-XD(JJ+1)).GT..1)ISENS(LMO(JJ))=0
      IF(ABS(XD(NOBS+1-JJ)-XD(NOBS-JJ)).GT..1)THEN
         ISENS(LMO(NOBS+1-JJ))=0
      ENDIF
      IF(ISENS(LMO(JJ)).EQ.1.AND.ISENS(LMO(NOBS+1-JJ)).EQ.1)THEN
          GO TO 999
      ENDIF
  99  CONTINUE
  999 continue
C
C  SET MIN AND MAX PACS TO FURTHEST LEFT/RIGHT UNCONSTRAINED
C    LEGISLATORS
C
      do 77 j=1,10
      if(isens(lmo(j)).eq.0)go to 77
      ksmin=lmo(j)
      go to 78
  77  continue
  78  do 79 j=1,10
      if(isens(lmo(NOBS+1-j)).eq.0)go to 79
      ksmax=lmo(NOBS+1-j)
      go to 76
  79  continue
  76  continue
      AA=(XDATA(KSMIN)+XDATA(KSMAX))/2.0
      BB=XDATA(KSMAX)-AA
      write(KIO,1111)aa,bb,XDATA(ksmin),XDATA(ksmax)
C
C  SET MIN PAC VALUE TO -1 AND MAX LEGISLATOR VALUE TO +1
C    AND NORMALIZE COORDINATES TO RUN FROM -1 TO +1
C
      DO 11 I=1,NOBS
      zzz=xdata(i)
      IF(ISENS(I).EQ.0.AND.XDATA(I).LT.0.0)XDATA(I)=-1.0
      IF(ISENS(I).EQ.0.AND.XDATA(I).GT.0.0)XDATA(I)=1.0
      IF(ISENS(I).EQ.0)GO TO 1
      XDATA(I)=(XDATA(I)-AA)/BB
 1    write(jio,1111)ZZZ,XDATA(I)
11    continue
C
C  APPLY LINEAR TRANSFORMATION TO CONTEST COORDINATES
C
      DO 2 J=1,NRCALL
      XINCU(J)=ZMID(J)-DYN(J)
      CHALL(J)=ZMID(J)+DYN(J)
      XINCU(J)=(XINCU(J)-AA)/BB
      CHALL(J)=(CHALL(J)-AA)/BB
C      IF(XINCU(J).LT.XDATA(KSMIN))XINCU(J)=XDATA(KSMIN)
C      IF(XINCU(J).GT.XDATA(KSMAX))XINCU(J)=XDATA(KSMAX)
C      IF(CHALL(J).LT.XDATA(KSMIN))CHALL(J)=XDATA(KSMIN)
C      IF(CHALL(J).LT.XDATA(KSMAX))CHALL(J)=XDATA(KSMAX)
      ZMID(J)=.5*(XINCU(J)+CHALL(J))
      DYN(J)=.5*(CHALL(J)-XINCU(J))
  2   CONTINUE
C
C  MULTIPLY WEIGHT BY SCALING FACTOR SO AS TO ACHIEVE CANCELLATION
C    IN EXPONENT OF UTILITY FUNCTION
C
      BBB(2)=BBB(2)*BB
C
C  SET NEW MIN AND MAX VALUES
C
      SSS(1)=XDATA(KSMIN)
      SSS(2)=XDATA(KSMAX)
      SSS(3)=XDATA(LMO(2))
      SSS(4)=XDATA(LMO(NOBS-1))
      RETURN
      END
C
C  *************************************************************************
C    SUBROUTINE GRID2---CALLED BY RPRINT.  PERFORMS GRID SEARCH WHEN 
C      ESTIMATES OF ROLL CALL PARAMETERS ARE UNREALISTIC.
C             IF KKS = 1 THEN THE YES AND NO OUTCOMES ARE OFF THE 
C                        OPPOSITE ENDS OF THE DIMENSION
C             IF KKS = 2 THEN ZMID(.) > FURTHEST RIGHT LEGISLATOR
C             IF KKS = 3 THEN ZMID(.) < FURTHEST LEFT LEGISLATOR
C  *************************************************************************
C
      SUBROUTINE GRID2(NOBS,NEQ,KIO,B,KKS)
      DIMENSION ZY(200),B(1601)
      COMMON /XXCOM/ ZMID(1601),XDATA(513),DYN(1601),ldata(501,601),
     CUCUT(501),UINC(501),XINC(1601)
      COMMON /BOOK/ BBB(50)
      COMMON /SENMIN/ sss(100),KSMIN,KSMAX
      COMMON /LUCK/ YBIGL(1601),YYBIGL(1601)
      COMMON /LIKE/ SVLNL,FNLNL,ICNVG,ITT,NVAL
 1000 FORMAT(' OFF OPPOSITE ENDS OUTCOMES'/1X,3F10.4)
 1001 FORMAT(' NEW ESTIMATES OF DYN AND ZM FROM GRID SEARCH'/1X,3F10.4)
 1002 FORMAT(' UNREALISTIC ESTIMATES OF DYN AND ZM'/1X,3F10.4,1X,I2)
      NCUT=100
      BMAX=-999999999.0
      WEIGHT=BBB(2)

C
C  TAKE INTO ACCOUNT POLARITY OF ROLL CALL
C
      XSIGN=+1.0
      IF(B(2).LE.0.0)XSIGN=-1.0
C
C  ***** OUTCOMES OFF OPPOSITE ENDS OF DIMENSION *****
C
      IF(KKS.EQ.1)THEN
C
C  SETUP ANCHOR POINT (ZF) TO START GRID SEARCH SUCH THAT AT LEAST ONE OF THE 
C     OUTCOMES IS IN THE INTERIOR OF THE DIMENSION
C
C          ZF/KSMIN--------------0--ZMID-------KSMAX
C
           IF(B(1).GT.0.0)ZF=XDATA(KSMIN)
C
C       ZF----KSMIN----ZMID------0-------------KSMAX
C
           IF(B(1).LE.0.0)ZF=B(1)-ABS(XDATA(KSMAX)-B(1))
           DYNDYN=ABS(B(1)-ZF)
           XINC2=DYNDYN/FLOAT(NCUT)
C
C  SETUP NCUT SEARCH POINTS FROM FAR LEFT ANCHOR POINT (ZF) INTO INTERIOR
C
           DO 1 J=1,NCUT
           XJ=FLOAT(J)
  1        ZY(J)=ZF+XINC2*(XJ-1.0)
C
C  CALCULATE LOG LIKELIHOOD FOR EACH OF THE NCUT POINTS
C
           DO 2 J=1,NCUT
           XLX=0.0
           DO 3 K=1,NOBS
           ICH=LDATA(K,NEQ)
           DL=(WEIGHT*(XDATA(K)-ZY(J)))**2
           DR=(WEIGHT*(XDATA(K)-2.0*B(1)+ZY(J)))**2
           AA=BBB(1)*EXP(-DL/2.0)
           BB=BBB(1)*EXP(-DR/2.0)
           IF(B(2).GE.0.0)AA=AA*EXP(UINC(K))
           IF(B(2).LT.0.0)BB=BB*EXP(UINC(K))
           ENIII=EXP(UCUT(K)+3*AA)
           EIIC=EXP(2*AA+BB)
           ENNIIC=EXP(2*UCUT(K)+2*AA+BB)
           ENICC=EXP(UCUT(K)+AA+2*BB)
           ENIIC=EXP(UCUT(K)+2*AA+BB)
           EICC=EXP(AA+2*BB)
           ENNICC=EXP(2*UCUT(K)+AA+2*BB)
           ENCCC=EXP(UCUT(K)+3*BB)
           FAB=ENNIIC-EIIC-EICC+ENNICC
           FAA=ENIII+2*EIIC+ENICC
           FBB=ENIIC+2*EICC+ENCCC
           PHI=ENIII+EIIC+ENNIIC+ENICC+ENIIC+EICC+ENNICC+ENCCC
           CC=ALOG(PHI)
           IF(B(2).GE.0.0)THEN
                IF(ICH.EQ.0)XLX=XLX+ALOG(FAB)-CC
                IF(ICH.EQ.1)XLX=XLX+ALOG(FAA)-CC
                IF(ICH.EQ.-1)XLX=XLX+ALOG(FBB)-CC
           ENDIF
           IF(B(2).LT.0.0)THEN
                IF(ICH.EQ.0)XLX=XLX+ALOG(FAB)-CC
                IF(ICH.EQ.1)XLX=XLX+ALOG(FBB)-CC
                IF(ICH.EQ.-1)XLX=XLX+ALOG(FAA)-CC
           ENDIF
  3        CONTINUE
           AMX=AMAX1(XLX,BMAX)
           IF(AMX.EQ.XLX)KJ=J
           BMAX=AMX
  2        CONTINUE
           WRITE(KIO,1000)B(1),B(2),YBIGL(NEQ)
      ENDIF
C
C ***** ZMID(.) > FURTHEST RIGHT PAC *****
C
      IF(KKS.EQ.2)THEN
C
C  SET MIDPOINT TO FURTHEST RIGHT PAC
C
           B(1)=XDATA(KSMAX)
           DYNDYN=1.0
           XINC2=DYNDYN/FLOAT(NCUT)
C
C  SET ANCHOR POINT (ZF) FOR GRID SEARCH TO 1 UNIT LEFT OF FURTHEST RIGHT 
C     LEGISLATOR
C
           ZF=XDATA(KSMAX)-DYNDYN
           DO 11 J=1,NCUT
           XJ=FLOAT(J)
  11       ZY(J)=ZF+XINC2*(XJ-1.0)
           DO 12 J=1,NCUT
           XLX=0.0
           DO 13 K=1,NOBS
           ICH=LDATA(K,NEQ)
           DL=(WEIGHT*(XDATA(K)-ZY(J)))**2
           DR=(WEIGHT*(XDATA(K)-2.0*XDATA(KSMAX)+ZY(J)))**2
           AA=BBB(1)*EXP(-DL/2.0)
           BB=BBB(1)*EXP(-DR/2.0)
           IF(B(2).GE.0.0)AA=AA*EXP(UINC(K))
           IF(B(2).LT.0.0)BB=BB*EXP(UINC(K))
           ENIII=EXP(UCUT(K)+3*AA)
           EIIC=EXP(2*AA+BB)
           ENNIIC=EXP(2*UCUT(K)+2*AA+BB)
           ENICC=EXP(UCUT(K)+AA+2*BB)
           ENIIC=EXP(UCUT(K)+2*AA+BB)
           EICC=EXP(AA+2*BB)
           ENNICC=EXP(2*UCUT(K)+AA+2*BB)
           ENCCC=EXP(UCUT(K)+3*BB)
           FAB=ENNIIC-EIIC-EICC+ENNICC
           FAA=ENIII+2*EIIC+ENICC
           FBB=ENIIC+2*EICC+ENCCC
           PHI=ENIII+EIIC+ENNIIC+ENICC+ENIIC+EICC+ENNICC+ENCCC
           CC=ALOG(PHI)
           IF(B(2).GE.0.0)THEN
                IF(ICH.EQ.0)XLX=XLX+ALOG(FAB)-CC
                IF(ICH.EQ.1)XLX=XLX+ALOG(FAA)-CC
                IF(ICH.EQ.-1)XLX=XLX+ALOG(FBB)-CC
           ENDIF
           IF(B(2).LT.0.0)THEN
                IF(ICH.EQ.0)XLX=XLX+ALOG(FAB)-CC
                IF(ICH.EQ.1)XLX=XLX+ALOG(FBB)-CC
                IF(ICH.EQ.-1)XLX=XLX+ALOG(FAA)-CC
           ENDIF
  13       CONTINUE
           AMX=AMAX1(XLX,BMAX)
           IF(AMX.EQ.XLX)KJ=J
           BMAX=AMX
  12       CONTINUE
           WRITE(KIO,1002)B(1),B(2),YBIGL(NEQ),KKS
      ENDIF
C
C  ***** ZMID(.) < FURTHEST LEFT LEGISLATOR *****
C
      IF(KKS.EQ.3)THEN
           B(1)=XDATA(KSMIN)
           DYNDYN=1.0
           XINC2=DYNDYN/FLOAT(NCUT)
C
C  SET ANCHOR POINT (ZF) FOR GRID SEARCH 1 UNIT TO THE LEFT OF THE FURTHEST
C    LEFT LEGISLATOR
C
           ZF=XDATA(KSMIN)-DYNDYN
           DO 21 J=1,NCUT
           XJ=FLOAT(J)
  21       ZY(J)=ZF+XINC2*(XJ-1.0)
           DO 22 J=1,NCUT
           XLX=0.0
           DO 23 K=1,NOBS
           ICH=LDATA(K,NEQ)
           DL=(WEIGHT*(XDATA(K)-ZY(J)))**2
           DR=(WEIGHT*(XDATA(K)-2.0*XDATA(KSMIN)+ZY(J)))**2
           AA=BBB(1)*EXP(-DL/2.0)
           BB=BBB(1)*EXP(-DR/2.0)
           IF(B(2).GE.0.0)AA=AA*EXP(UINC(K))
           IF(B(2).LT.0.0)BB=BB*EXP(UINC(K))
           ENIII=EXP(UCUT(K)+3*AA)
           EIIC=EXP(2*AA+BB)
           ENNIIC=EXP(2*UCUT(K)+2*AA+BB)
           ENICC=EXP(UCUT(K)+AA+2*BB)
           ENIIC=EXP(UCUT(K)+2*AA+BB)
           EICC=EXP(AA+2*BB)
           ENNICC=EXP(2*UCUT(K)+AA+2*BB)
           ENCCC=EXP(UCUT(K)+3*BB)
           FAB=ENNIIC-EIIC-EICC+ENNICC
           FAA=ENIII+2*EIIC+ENICC
           FBB=ENIIC+2*EICC+ENCCC
           PHI=ENIII+EIIC+ENNIIC+ENICC+ENIIC+EICC+ENNICC+ENCCC
           CC=ALOG(PHI)
           IF(B(2).GE.0.0)THEN
                IF(ICH.EQ.0)XLX=XLX+ALOG(FAB)-CC
                IF(ICH.EQ.1)XLX=XLX+ALOG(FAA)-CC
                IF(ICH.EQ.-1)XLX=XLX+ALOG(FBB)-CC
           ENDIF
           IF(B(2).LT.0.0)THEN
                IF(ICH.EQ.0)XLX=XLX+ALOG(FAB)-CC
                IF(ICH.EQ.1)XLX=XLX+ALOG(FBB)-CC
                IF(ICH.EQ.-1)XLX=XLX+ALOG(FAA)-CC
           ENDIF
  23       CONTINUE
           AMX=AMAX1(XLX,BMAX)
           IF(AMX.EQ.XLX)KJ=J
           BMAX=AMX
  22       CONTINUE
           WRITE(KIO,1002)B(1),B(2),YBIGL(NEQ),KKS
      ENDIF
C
C  STORE NEW VALUE OF DYN(.)--THE SPREAD
C
      B(2)=(B(1)-ZY(KJ))*XSIGN
      YBIGL(NEQ)=AMX
      FNLNL=AMX
      WRITE(KIO,1001)B(1),B(2),AMX
      RETURN
      END
C
C  ***************************************************************************
C    SUBROUTINE CORR--CALLED BY MAIN.  CALCULATES CORRELATION BETWEEN CURRENT
C       SET OF PARAMETERS AND PARAMETERS FROM PREVIOUS ITERATION.           
C       IF KHR = 1 CALCULATE CORRELATIONS FOR ROLL CALL PHASE.   
C       IF KHR = 2 CALCULATE CORRELATIONS FOR LEGISLATOR PHASE.
C       IF KHR = 0 CALCULATE CORRELATIONS FOR ALL PARAMETERS
C  ***************************************************************************
C
      SUBROUTINE CORR(ALP,BTA,RR,KHR)
      DIMENSION ALP(4),BTA(4),RR(4)
      COMMON /SAVE/ XSAVE(513,8,2),ZSAVE(1601,8,2),CSAVE(1601,8),
     CQSAVE(1601,8,2),RSAVE(1601,8),SSAVE(513,8,2)
      COMMON /MINE/ NS,NQ,NRCALL,NSTEP,NEQ,ISENS(1000),
     CJAN,JANLST,JIO,KIO,NOBS,NOPAR,IFDRV,NFEVAL,
     CMAXIT,MAXSQZ,KNOL,KSTRT
9090  FORMAT(1X,I4,4F9.5)
C
C  CALCULATE CORRELATIONS FOR ROLL CALL PHASE
C
      IF(KHR.EQ.1)THEN
           ASUM=0.0
           BSUM=0.0
           CSUM=0.0
           DSUM=0.0
           ESUM=0.0
           AASUM=0.0
           BBSUM=0.0
           CCSUM=0.0
           DDSUM=0.0
           EESUM=0.0
           VSUM=0.0
           WSUM=0.0
           XSUM=0.0
           YSUM=0.0
           ZSUM=0.0
           VVSUM=0.0
           WWSUM=0.0
           XXSUM=0.0
           YYSUM=0.0
           ZZSUM=0.0
           DO 3 I=1,NRCALL
           ASUM=ASUM+ZSAVE(I,1,1)
           AASUM=AASUM+CSAVE(I,1)
           BSUM=BSUM+ZSAVE(I,1,1)**2
           BBSUM=BBSUM+CSAVE(I,1)**2
           CSUM=CSUM+ZSAVE(I,2,1)
           CCSUM=CCSUM+CSAVE(I,2)
           DSUM=DSUM+ZSAVE(I,2,1)**2
           DDSUM=DDSUM+CSAVE(I,2)**2
           EESUM=EESUM+CSAVE(I,1)*CSAVE(I,2)
           ESUM=ESUM+ZSAVE(I,1,1)*ZSAVE(I,2,1)
           VSUM=VSUM+QSAVE(I,1,1)
           VVSUM=VVSUM+RSAVE(I,1)
           WSUM=WSUM+QSAVE(I,1,1)**2
           WWSUM=WWSUM+RSAVE(I,1)**2
           XSUM=XSUM+ZSAVE(I,2,1)
           XXSUM=XXSUM+CSAVE(I,2)
           YSUM=YSUM+ZSAVE(I,2,1)**2
           YYSUM=YYSUM+RSAVE(I,2)**2
           ZZSUM=ZZSUM+RSAVE(I,1)*CSAVE(I,2)
           ZSUM=ZSUM+QSAVE(I,1,1)*ZSAVE(I,2,1)
  3        CONTINUE
           XCALL=FLOAT(NRCALL)
           AA=XCALL*ESUM-ASUM*CSUM
           BB=XCALL*BSUM-ASUM*ASUM
           CC=XCALL*DSUM-CSUM*CSUM
           DD=DSUM*ASUM-CSUM*ESUM
           VV=XCALL*ZSUM-VSUM*XSUM
           WW=XCALL*WSUM-VSUM*VSUM
           XX=XCALL*YSUM-XSUM*XSUM
           YY=YSUM*VSUM-XSUM*ZSUM
           ALP(1)=DD/CC
           ALP(3)=YY/XX
           BTA(1)=AA/CC
           BTA(3)=VV/XX
           RR(1)=AA/SQRT(ABS(BB*CC))
           RR(3)=VV/SQRT(ABS(WW*XX))
           RR(1)=RR(1)*RR(1)
           RR(3)=RR(3)*RR(3)
           AA=XCALL*EESUM-AASUM*CCSUM
           BB=XCALL*BBSUM-AASUM*AASUM
           CC=XCALL*DDSUM-CCSUM*CCSUM
           DD=DDSUM*AASUM-CCSUM*EESUM
           VV=XCALL*ZZSUM-VVSUM*XXSUM
           WW=XCALL*WWSUM-VVSUM*VVSUM
           XX=XCALL*YYSUM-XXSUM*XXSUM
           YY=YSUM*VVSUM-XXSUM*ZZSUM
           ALP(2)=DD/CC
           ALP(4)=YY/XX
           BTA(2)=AA/CC
           BTA(4)=VV/XX
           RR(2)=AA/SQRT(ABS(BB*CC))
           RR(4)=VV/SQRT(ABS(WW*XX))
           RR(2)=RR(2)*RR(2)
           RR(4)=RR(4)*RR(4)
           WRITE(JIO,9090)KHR,RR(1),RR(2),RR(3),RR(4)
      ENDIF
C
C  CALCULATE CORRELATIONS FOR LEGISLATOR PHASE
C
      IF(KHR.EQ.2)THEN
           ASUM=0.0
           BSUM=0.0
           CSUM=0.0
           DSUM=0.0
           ESUM=0.0
           AASUM=0.0
           BBSUM=0.0
           CCSUM=0.0
           DDSUM=0.0
           EESUM=0.0
           DO 11 I=1,NOBS
           ASUM=ASUM+XSAVE(I,1,1)
           BSUM=BSUM+XSAVE(I,1,1)**2
           CSUM=CSUM+XSAVE(I,2,1)
           DSUM=DSUM+XSAVE(I,2,1)**2
           ESUM=ESUM+XSAVE(I,1,1)*XSAVE(I,2,1)
           AASUM=AASUM+SSAVE(I,1,1)
           BBSUM=BBSUM+SSAVE(I,1,1)**2
           CCSUM=CCSUM+XSAVE(I,2,1)
           DDSUM=DDSUM+XSAVE(I,2,1)**2
  11       EESUM=EESUM+SSAVE(I,1,1)*XSAVE(I,2,1)
           XNOBS=FLOAT(NOBS)
           AA=XNOBS*ESUM-ASUM*CSUM
           BB=XNOBS*BSUM-ASUM*ASUM
           CC=XNOBS*DSUM-CSUM*CSUM
           DD=DSUM*ASUM-CSUM*ESUM
           ALP(1)=DD/CC
           BTA(1)=AA/CC
           RR(1)=AA/SQRT(BB*CC)
           RR(1)=RR(1)*RR(1)
           AA=XNOBS*EESUM-AASUM*CCSUM
           BB=XNOBS*BBSUM-AASUM*AASUM
           CC=XNOBS*DDSUM-CCSUM*CCSUM
           DD=DDSUM*AASUM-CCSUM*EESUM
           ALP(2)=DD/CC
           BTA(2)=AA/CC
           RR(2)=AA/SQRT(BB*CC)
           RR(2)=RR(2)*RR(2)
           WRITE(JIO,9090)KHR,RR(1),RR(2)
      ENDIF
C
C  CALCULATE CORRELATION OVER ALL PARAMETERS
C
      IF(KHR.EQ.0)THEN
           AASUM=0.0
           BBSUM=0.0
           CCSUM=0.0
           DDSUM=0.0
           EESUM=0.0
           ASUM=0.0
           BSUM=0.0
           CSUM=0.0
           DSUM=0.0
           ESUM=0.0
           DO 21 I=1,NOBS
           ASUM=ASUM+XSAVE(I,1,1)
           BSUM=BSUM+XSAVE(I,1,1)**2
           CSUM=CSUM+XSAVE(I,2,1)
           DSUM=DSUM+XSAVE(I,2,1)**2
  21       ESUM=ESUM+XSAVE(I,1,1)*XSAVE(I,2,1)
           DO 23 I=1,NRCALL
           ASUM=ASUM+ZSAVE(I,1,1)
           AASUM=AASUM+CSAVE(I,1)
           BSUM=BSUM+ZSAVE(I,1,1)**2
           BBSUM=BBSUM+CSAVE(I,1)**2
           CSUM=CSUM+ZSAVE(I,2,1)
           CCSUM=CCSUM+CSAVE(I,2)
           DSUM=DSUM+ZSAVE(I,2,1)**2
           DDSUM=DDSUM+CSAVE(I,2)**2
           EESUM=EESUM+CSAVE(I,1)*CSAVE(I,2)
           ESUM=ESUM+ZSAVE(I,1,1)*ZSAVE(I,2,1)
  23       CONTINUE
           ASUM=ASUM+AASUM
           BSUM=BSUM+BBSUM
           CSUM=CSUM+CCSUM
           DSUM=DSUM+DDSUM
           ESUM=ESUM+EESUM
           XCALL=FLOAT(NOBS+2*NRCALL)
           AA=XCALL*ESUM-ASUM*CSUM
           BB=XCALL*BSUM-ASUM*ASUM
           CC=XCALL*DSUM-CSUM*CSUM
           DD=DSUM*ASUM-CSUM*ESUM
           ALP(1)=DD/CC
           BTA(1)=AA/CC
           RR(1)=AA/SQRT(ABS(BB*CC))
           RR(1)=RR(1)*RR(1)
      ENDIF
      RETURN
      END

      SUBROUTINE CPUTIM(KTIM1)
      COMMON /XIME/ NTIME(20),NITR,MSEC
C
      call gettim(itim1,itim2,itim3,itim4)
      mmsec=itim1*60*60+itim2*60+itim3
      KTIM1=mmsec-msec
      RETURN
      END
C
C *******************************************************************
C
C   START-SUBROUTINE TO GET STARTING VALUES 
C
C *******************************************************************
C
      SUBROUTINE START
      dimension xdem(389),xrep(389),npty(389),
     clrep(400),ldem(400),COORD(400),SCOORD(400),
     CNUMB(500),CHALL(500)
      character*1 kname(500,25),knrep(500,25),kndem(500,25),knpac(25)
      COMMON /XXCOM/ ZMID(1601),XDATA(513),DYN(1601),ldata(501,601),
     CUCUT(501),UINC(501),XINC(1601)
      COMMON /BOOK/ BBB(50)
      COMMON /MINE/ NS,NQ,NRCALL,NSTEP,NEQ,ISENS(1000),
     CJAN,JANLST,JIO,KIO,NOBS,NOPAR,IFDRV,NFEVAL,
     CMAXIT,MAXSQZ,KNOL,KSTRT
   30 format(i5,5x,i1,1x,25A1,f7.3)
   40 format(4x,500i3)
 1250 format(1x,25a1,4x,500i2)
 1260 format(51x,25a1)
 1280 format(1x,i4,3f7.3)
  300 format(6i8)
  305 format(5i7,2f7.3)
  310 format(1x,3f7.3)
  320 FORMAT(5X,2F7.3)
  400 FORMAT(1X,25A1,4X,400I2)
  410 format(i5,4x,i1,1x,10A1,f7.3)
  420 FORMAT(1X,I4,1X,3F7.3)
      i = 0
      id = 0
      ir = 0
   90 read(25,30,end=89)numb(I+1),npty(i+1),(kname(I+1,j),j=1,25),
     CCOORD(i+1)
      i=i+1
      go to 90
   89 CONTINUE
      AA=(COORD(1)+COORD(NRCALL))/2.0
      BB=COORD(NRCALL)-AA
      DO 66 I=1,NRCALL
      COORD(I)=(COORD(I)-AA)/BB
      XINC(I)=COORD(I)
   66 CONTINUE
      DO 67 I=1,NRCALL
      if(npty(i).eq.1)then
           id=id+1
           xdem(id)=coord(i)
           ldem(id)=numb(I)
           do 42 j=1,10
  42       kndem(id,j)=kname(I,j)
      endif
      if(npty(i).eq.2)then
           ir=ir+1
           xrep(ir)=coord(i)
           lrep(ir)=numb(I)
           do 43 j=1,10
  43       knrep(ir,j)=kname(I,j)
      endif
  67  CONTINUE
      id=int(id/2)
      ir=int(ir/2)  
      lj = 0
      do 150 l = 1,NRCALL
      if(npty(l).ne.1)go to 150
      lj = lj + 1
      lq = ldem(lj)
      zmid(lq) = .5*(xdem(lj)+xrep(ir))
      DYN(lq) = .5*(xrep(ir)-xdem(lj))
  150 continue
      lk = 0
      do 160 ll=1,NRCALL
      if(npty(ll).ne.2)go to 160
      lk=lk+1          
      lr = lrep(lk)
      zmid(lr) = .5*(xrep(lk)+xdem(id))
      DYN(lr) = .5*(xdem(id)-xrep(lk))
  160 continue 
    1 continue
c      DO 34 KK=1,NRCALL
c      READ(26,420)KKL,ZMID(KK),DYN(KK)
c      XINC(KK)=ZMID(KK)-DYN(KK)
c      CHALL(KK)=ZMID(KK)+DYN(KK)     
c  34  CONTINUE
c      AA=(XINC(1)+XINC(NRCALL))/2.0
c      BB=XINC(NRCALL)-AA
c      DO 35 KJ=1,NRCALL
c      XINC(KJ)=(XINC(KJ)-AA)/BB
c      CHALL(KJ)=(CHALL(KJ)-AA)/BB
c      ZMID(KJ)=.5*(XINC(KJ)+CHALL(KJ))
c      DYN(KJ)=.5*(CHALL(KJ)-XINC(KJ))
c  35  CONTINUE
      XMIN=0.0
      XMAX=0.0
      DO 260 I=1,NOBS
      BETA=BBB(1)
      WTSQ=.5*BBB(2)*BBB(2)
      KEXL=0
      KEXR=0
      IDD=0
      DO 270 KK = 1,NRCALL
      IF(LDATA(I,KK).EQ.1)THEN
         IDD=IDD+1
         SCOORD(IDD)=COORD(KK)
      ENDIF
  270 CONTINUE
      IT=INT(IDD/2)
      XDATA(I)=SCOORD(IT)
  260 CONTINUE
      DO 500 I=1,NOBS
      UINC(I)=0.0
      UCUT(I)=1.00
  500 CONTINUE
      DO 600 I=1,NOBS
      IF(XDATA(I).GT.XMAX)XMAX=XDATA(I)
      IF(XDATA(I).LT.XMIN)XMIN=XDATA(I)
600   CONTINUE
      AA=(XMIN+XMAX)/2
      BB=XMAX-AA
      CC=FLOAT(2.0/NOBS)
      DO 601 I=1,NOBS
      XDATA(I)=(XDATA(I)-AA)/BB
      WRITE(KIO,310)XDATA(I)
601   CONTINUE
      NSTEP=2
      NOPAR=3
      call MAXLIK
      CALL NORMZ
      RETURN
      STOP
      END 