C
C  *************************************************************************
C    SUBROUTINE NORMZ---CALLED BY MAXLIK DURING UTILITY FUNCTION PHASE.
C       CHECKS FOR SAG IN LEGISLATOR COORDINATES AND CONSTRAINS "SAGGED"
C       LEGISLATORS FROM BEING FURTHER ESTIMATED.  READJUSTS LEGISLATOR
C       COORDINATES TO LIE BETWEEN -1 AND +1.  READJUSTS ROLL CALL OUTCOME
C       COORDINATES SO THAT SUM OF DYN**2 = SUM OF ABS(XI-ZMID)*DYN.
C  *************************************************************************
C
      SUBROUTINE NORMZ
      DIMENSION XD(1000),YD(1000),LMO(1000),XINCU(500),CHALL(500)
      COMMON /XXCOM/ ZMID(1601),XDATA(513),DYN(1601),ldata(501,601),
     CUCUTI(501),UCUTC(501),XINC(1601)
      COMMON /MINE/ NS,NQ,NRCALL,NSTEP,NEQ,ISENS(1000),
     CJAN,JANLST,JIO,KIO,NOBS,NOPAR,IFDRV,NFEVAL,
     CMAXIT,MAXSQZ,KNOL,KSTRT
      COMMON /SENMIN/ sss(100),KSMIN,KSMAX
      COMMON /BOOK/ BBB(50)
 1000 FORMAT(' FURTHEST LEFT SENATOR=',F10.4,2X,
     C'FURTHEST RIGHT SENATOR=',F10.4/14X,'OLD LEFT=',F10.4,
     C15X,'OLD RIGHT=',F10.4/' POSITIONS: LEFT=',I5,3X,'RIGHT=',I5)
 1001 FORMAT('    ADJUSTMENT TO OUTCOME COORDINATES=',2F10.4)
 1002 FORMAT(I6,4f10.4,4I6)
 1111 format(4f10.4)
      NNRCALL=INT(2*NRCALL)
      DO 3 I=1,NRCALL
      CHALL(I)=ZMID(I)+DYN(I)
      XINCU(I)=ZMID(I)-DYN(I)
      YD(I)=XINCU(I)
      YD(NRCALL+I)=CHALL(I)
  3   CONTINUE
      DO 4 J=1,NNRCALL
      XD(J)=YD(J)
  4   LMO(J)=J
      call RSORT(XD,NNRCALL,LMO)
C
C  EXAMINE LEGISLATOR CONFIGURATION FOR SAG.  IF SAG EXISTS, CONSTRAIN
C    ESTIMATION OF LEGISLATOR BY SETTING VALUE OF ISENS(.)=0.
C
      DO 99 JJ=1,20
      WRITE(KIO,1002)JJ,XD(JJ),XD(JJ+1),XD(NNRCALL+1-JJ),
     CXD(NNRCALL-JJ),ISENS(LMO(JJ)),ISENS(LMO(JJ+1)),
     CISENS(LMO(NNRCALL+1-JJ)),ISENS(LMO(NNRCALL-JJ))
      IF(ABS(XD(JJ)-XD(JJ+1)).GT..1)ISENS(LMO(JJ))=0
      IF(ABS(XD(NNRCALL+1-JJ)-XD(NNRCALL-JJ)).GT..1)THEN
         ISENS(LMO(NNRCALL+1-JJ))=0
      ENDIF
      IF(ISENS(LMO(JJ)).EQ.1.AND.ISENS(LMO(NNRCALL+1-JJ)).EQ.1)THEN
          GO TO 999
      ENDIF
  99  CONTINUE
  999 continue
C
C  SET MIN AND MAX LEGISLATORS TO FURTHEST LEFT/RIGHT UNCONSTRAINED
C    LEGISLATORS
C
      do 77 j=1,10
      if(isens(lmo(j)).eq.0)go to 77
      ksmin=lmo(j)
      go to 78
  77  continue
  78  do 79 j=1,10
      if(isens(lmo(NNRCALL+1-j)).eq.0)go to 79
      ksmax=lmo(NNRCALL+1-j)
      go to 76
  79  continue
  76  continue
      AA=(YD(KSMIN)+YD(KSMAX))/2.0
      BB=YD(KSMAX)-AA
      write(kio,1111)aa,bb,YD(ksmin),YD(ksmax)
C
C  SET MIN LEGISLATOR VALUE TO -1 AND MAX LEGISLATOR VALUE TO +1
C    AND NORMALIZE COORDINATES TO RUN FROM -1 TO +1
C
      DO 1 I=1,NNRCALL
      IF(ISENS(I).EQ.0.AND.YD(I).LT.0.0)YD(I)=-1.0
      IF(ISENS(I).EQ.0.AND.YD(I).GT.0.0)YD(I)=1.0
      IF(ISENS(I).EQ.0)GO TO 1
      YD(I)=(YD(I)-AA)/BB
  1   CONTINUE
      DO 11 K=1,NRCALL
      ZMID(K)=.5*(YD(K)+YD(K+NRCALL))
      DYN(K) = .5*(YD(K+NRCALL)-YD(K))
      XINC(K)=ZMID(K)-DYN(K)
 11   CONTINUE
C
C  APPLY LINEAR TRANSFORMATION TO PAC COORDINATES
C
      DO 2 J=1,NOBS
      XDATA(J)=(XDATA(J)-AA)/BB
  2   CONTINUE
C
C  MULTIPLY WEIGHT BY SCALING FACTOR SO AS TO ACHIEVE CANCELLATION
C    IN EXPONENT OF UTILITY FUNCTION
C
      BBB(2)=BBB(2)*BB
C
C  SET NEW MIN AND MAX VALUES
C
      SSS(1)=YD(KSMIN)
      SSS(2)=YD(KSMAX)
      SSS(3)=YD(LMO(2))
      SSS(4)=YD(LMO(NNRCALL-1))
      RETURN
      END
C
C  *************************************************************************
C    SUBROUTINE GRID2---CALLED BY RPRINT.  PERFORMS GRID SEARCH WHEN 
C      ESTIMATES OF ROLL CALL PARAMETERS ARE UNREALISTIC.
C             IF KKS = 1 THEN THE YES AND NO OUTCOMES ARE OFF THE 
C                        OPPOSITE ENDS OF THE DIMENSION
C             IF KKS = 2 THEN ZMID(.) > FURTHEST RIGHT LEGISLATOR
C             IF KKS = 3 THEN ZMID(.) < FURTHEST LEFT LEGISLATOR
C  *************************************************************************
C
      SUBROUTINE GRID2(NOBS,NEQ,KIO,B,KKS)
      DIMENSION ZY(200),B(1601)
      COMMON /XXCOM/ ZMID(1601),XDATA(513),DYN(1601),ldata(501,601),
     CUCUT(501),UINC(501),XINC(1601)
      COMMON /BOOK/ BBB(50)
      COMMON /SENMIN/ sss(100),KSMIN,KSMAX
      COMMON /LUCK/ YBIGL(1601),YYBIGL(1601)
      COMMON /LIKE/ SVLNL,FNLNL,ICNVG,ITT,NVAL
 1000 FORMAT(' OFF OPPOSITE ENDS OUTCOMES'/1X,3F10.4)
 1001 FORMAT(' NEW ESTIMATES OF DYN AND ZM FROM GRID SEARCH'/1X,3F10.4)
 1002 FORMAT(' UNREALISTIC ESTIMATES OF DYN AND ZM'/1X,3F10.4)
      NCUT=100
      BMAX=-999999999.0
      WEIGHT=BBB(2)
C
C  TAKE INTO ACCOUNT POLARITY OF ROLL CALL
C
      XSIGN=+1.0
      IF(B(1).LE.0.0)XSIGN=-1.0
C
C  ***** OUTCOMES OFF OPPOSITE ENDS OF DIMENSION *****
C
      IF(KKS.EQ.1)THEN
           DYNDYN=ABS(B(1))
           XINC2=DYNDYN/FLOAT(NCUT)
C
C  SETUP ANCHOR POINT (ZF) TO START GRID SEARCH SUCH THAT AT LEAST ONE OF THE 
C     OUTCOMES IS IN THE INTERIOR OF THE DIMENSION
C
C          ZF/KSMIN--------------0--ZMID-------KSMAX
C
           IF(B(2).GT.0.0)ZF=XDATA(KSMIN)
C
C       ZF----KSMIN----ZMID------0-------------KSMAX
C
           IF(B(2).LE.0.0)ZF=B(2)-ABS(XDATA(KSMAX)-B(2))
C
C  SETUP NCUT SEARCH POINTS FROM FAR LEFT ANCHOR POINT (ZF) INTO INTERIOR
C
           DO 1 J=1,NCUT
           XJ=FLOAT(J)
  1        ZY(J)=ZF+XINC2*(XJ-1.0)
C
C  CALCULATE LOG LIKELIHOOD FOR EACH OF THE NCUT POINTS
C
           DO 2 J=1,NCUT
           XLX=0.0
           DO 3 K=1,NOBS
           ICH=LDATA(K,NEQ)
           IF(ICH.LE.0)GO TO 3
           DY=(WEIGHT*(XDATA(K)-ZY(J)))**2
           DN=(WEIGHT*(XDATA(K)-2.0*B(2)+ZY(J)))**2
           AA=BBB(1)*EXP(-DY/2.0)
           BB=BBB(1)*EXP(-DN/2.0)
           PHI=EXP(AA)+EXP(BB)
           CC=ALOG(PHI)
           IF(B(1).GE.0.0)THEN
                IF(ICH.EQ.1)XLX=XLX+AA-CC
                IF(ICH.EQ.2)XLX=XLX+BB-CC
           ENDIF
           IF(B(1).LT.0.0)THEN
                IF(ICH.EQ.2)XLX=XLX+AA-CC
                IF(ICH.EQ.1)XLX=XLX+BB-CC
           ENDIF
  3        CONTINUE
           AMX=AMAX1(XLX,BMAX)
           IF(AMX.EQ.XLX)KJ=J
           BMAX=AMX
  2        CONTINUE
C           WRITE(KIO,1000)B(1),B(2),YBIGL(NEQ)
      ENDIF
C
C ***** ZMID(.) > FURTHEST RIGHT LEGISLATOR *****
C
      IF(KKS.EQ.2)THEN
C
C  SET MIDPOINT TO FURTHEST RIGHT LEGISLATOR
C
           B(2)=XDATA(KSMAX)
           DYNDYN=1.0
           XINC2=DYNDYN/FLOAT(NCUT)
C
C  SET ANCHOR POINT (ZF) FOR GRID SEARCH TO 1 UNIT LEFT OF FURTHEST RIGHT 
C     LEGISLATOR
C
           ZF=XDATA(KSMAX)-DYNDYN
           DO 11 J=1,NCUT
           XJ=FLOAT(J)
  11       ZY(J)=ZF+XINC2*(XJ-1.0)
           DO 12 J=1,NCUT
           XLX=0.0
           DO 13 K=1,NOBS
           ICH=LDATA(K,NEQ)
           IF(ICH.LE.0)GO TO 13
           DY=(WEIGHT*(XDATA(K)-ZY(J)))**2
           DN=(WEIGHT*(XDATA(K)-2.0*XDATA(KSMAX)+ZY(J)))**2
           AA=BBB(1)*EXP(-DY/2.0)
           BB=BBB(1)*EXP(-DN/2.0)
           PHI=EXP(AA)+EXP(BB)
           CC=ALOG(PHI)
           IF(B(1).GE.0.0)THEN
                IF(ICH.EQ.1)XLX=XLX+AA-CC
                IF(ICH.EQ.2)XLX=XLX+BB-CC
           ENDIF
           IF(B(1).LT.0.0)THEN
                IF(ICH.EQ.2)XLX=XLX+AA-CC
                IF(ICH.EQ.1)XLX=XLX+BB-CC
           ENDIF
  13       CONTINUE
           AMX=AMAX1(XLX,BMAX)
           IF(AMX.EQ.XLX)KJ=J
           BMAX=AMX
  12       CONTINUE
C           WRITE(KIO,1002)B(1),B(2),YBIGL(NEQ)
      ENDIF
C
C  ***** ZMID(.) < FURTHEST LEFT LEGISLATOR *****
C
      IF(KKS.EQ.3)THEN
           B(2)=XDATA(KSMIN)
           DYNDYN=1.0
           XINC2=DYNDYN/FLOAT(NCUT)
C
C  SET ANCHOR POINT (ZF) FOR GRID SEARCH 1 UNIT TO THE LEFT OF THE FURTHEST
C    LEFT LEGISLATOR
C
           ZF=XDATA(KSMIN)-DYNDYN
           DO 21 J=1,NCUT
           XJ=FLOAT(J)
  21       ZY(J)=ZF+XINC2*(XJ-1.0)
           DO 22 J=1,NCUT
           XLX=0.0
           DO 23 K=1,NOBS
           ICH=LDATA(K,NEQ)
           IF(ICH.LE.0)GO TO 23
           DY=(WEIGHT*(XDATA(K)-ZY(J)))**2
           DN=(WEIGHT*(XDATA(K)-2.0*XDATA(KSMIN)+ZY(J)))**2
           AA=BBB(1)*EXP(-DY/2.0)
           BB=BBB(1)*EXP(-DN/2.0)
           PHI=EXP(AA)+EXP(BB)
           CC=ALOG(PHI)
           IF(B(1).GE.0.0)THEN
                IF(ICH.EQ.1)XLX=XLX+AA-CC
                IF(ICH.EQ.2)XLX=XLX+BB-CC
           ENDIF
           IF(B(1).LT.0.0)THEN
                IF(ICH.EQ.2)XLX=XLX+AA-CC
                IF(ICH.EQ.1)XLX=XLX+BB-CC
           ENDIF
  23       CONTINUE
           AMX=AMAX1(XLX,BMAX)
           IF(AMX.EQ.XLX)KJ=J
           BMAX=AMX
  22       CONTINUE
C           WRITE(KIO,1002)B(1),B(2),YBIGL(NEQ)
      ENDIF
C
C  STORE NEW VALUE OF DYN(.)--THE SPREAD
C
      B(1)=(B(2)-ZY(KJ))*XSIGN
      YBIGL(NEQ)=AMX
      FNLNL=AMX
C      WRITE(KIO,1001)B(1),B(2),AMX
      RETURN
      END
C
C  ***************************************************************************
C    SUBROUTINE CORR--CALLED BY MAIN.  CALCULATES CORRELATION BETWEEN CURRENT
C       SET OF PARAMETERS AND PARAMETERS FROM PREVIOUS ITERATION.           
C       IF KHR = 1 CALCULATE CORRELATIONS FOR ROLL CALL PHASE.   
C       IF KHR = 2 CALCULATE CORRELATIONS FOR LEGISLATOR PHASE.
C       IF KHR = 0 CALCULATE CORRELATIONS FOR ALL PARAMETERS
C  ***************************************************************************
C
      SUBROUTINE CORR(ALP,BTA,RR,KHR)
      DIMENSION ALP(4),BTA(4),RR(4)
      COMMON /SAVE/ XSAVE(513,8,2),ZSAVE(1601,8,2),CSAVE(1601,8),
     CQSAVE(1601,8,2),RSAVE(1601,8),SSAVE(513,8,2)
      COMMON /MINE/ NS,NQ,NRCALL,NSTEP,NEQ,ISENS(1000),
     CJAN,JANLST,JIO,KIO,NOBS,NOPAR,IFDRV,NFEVAL,
     CMAXIT,MAXSQZ,KNOL,KSTRT
9090  FORMAT(1X,I4,4F9.5)
C
C  CALCULATE CORRELATIONS FOR ROLL CALL PHASE
C
      IF(KHR.EQ.1)THEN
           ASUM=0.0
           BSUM=0.0
           CSUM=0.0
           DSUM=0.0
           ESUM=0.0
           AASUM=0.0
           BBSUM=0.0
           CCSUM=0.0
           DDSUM=0.0
           EESUM=0.0
           VSUM=0.0
           WSUM=0.0
           XSUM=0.0
           YSUM=0.0
           ZSUM=0.0
           VVSUM=0.0
           WWSUM=0.0
           XXSUM=0.0
           YYSUM=0.0
           ZZSUM=0.0
           DO 3 I=1,NRCALL
           ASUM=ASUM+ZSAVE(I,1,1)
           AASUM=AASUM+CSAVE(I,1)
           BSUM=BSUM+ZSAVE(I,1,1)**2
           BBSUM=BBSUM+CSAVE(I,1)**2
           CSUM=CSUM+ZSAVE(I,2,1)
           CCSUM=CCSUM+CSAVE(I,2)
           DSUM=DSUM+ZSAVE(I,2,1)**2
           DDSUM=DDSUM+CSAVE(I,2)**2
           EESUM=EESUM+CSAVE(I,1)*CSAVE(I,2)
           ESUM=ESUM+ZSAVE(I,1,1)*ZSAVE(I,2,1)
           VSUM=VSUM+QSAVE(I,1,1)
           VVSUM=VVSUM+RSAVE(I,1)
           WSUM=WSUM+QSAVE(I,1,1)**2
           WWSUM=WWSUM+RSAVE(I,1)**2
           XSUM=XSUM+ZSAVE(I,2,1)
           XXSUM=XXSUM+CSAVE(I,2)
           YSUM=YSUM+ZSAVE(I,2,1)**2
           YYSUM=YYSUM+RSAVE(I,2)**2
           ZZSUM=ZZSUM+RSAVE(I,1)*CSAVE(I,2)
           ZSUM=ZSUM+QSAVE(I,1,1)*ZSAVE(I,2,1)
  3        CONTINUE
           XCALL=FLOAT(NRCALL)
           AA=XCALL*ESUM-ASUM*CSUM
           BB=XCALL*BSUM-ASUM*ASUM
           CC=XCALL*DSUM-CSUM*CSUM
           DD=DSUM*ASUM-CSUM*ESUM
           VV=XCALL*ZSUM-VSUM*XSUM
           WW=XCALL*WSUM-VSUM*VSUM
           XX=XCALL*YSUM-XSUM*XSUM
           YY=YSUM*VSUM-XSUM*ZSUM
           ALP(1)=DD/CC
           ALP(3)=YY/XX
           BTA(1)=AA/CC
           BTA(3)=VV/XX
           RR(1)=AA/SQRT(ABS(BB*CC))
           RR(3)=VV/SQRT(ABS(WW*XX))
           RR(1)=RR(1)*RR(1)
           RR(3)=RR(3)*RR(3)
           AA=XCALL*EESUM-AASUM*CCSUM
           BB=XCALL*BBSUM-AASUM*AASUM
           CC=XCALL*DDSUM-CCSUM*CCSUM
           DD=DDSUM*AASUM-CCSUM*EESUM
           VV=XCALL*ZZSUM-VVSUM*XXSUM
           WW=XCALL*WWSUM-VVSUM*VVSUM
           XX=XCALL*YYSUM-XXSUM*XXSUM
           YY=YSUM*VVSUM-XXSUM*ZZSUM
           ALP(2)=DD/CC
           ALP(4)=YY/XX
           BTA(2)=AA/CC
           BTA(4)=VV/XX
           RR(2)=AA/SQRT(ABS(BB*CC))
           RR(4)=VV/SQRT(ABS(WW*XX))
           RR(2)=RR(2)*RR(2)
           RR(4)=RR(4)*RR(4)
           WRITE(JIO,9090)KHR,RR(1),RR(2),RR(3),RR(4)
      ENDIF
C
C  CALCULATE CORRELATIONS FOR LEGISLATOR PHASE
C
      IF(KHR.EQ.2)THEN
           ASUM=0.0
           BSUM=0.0
           CSUM=0.0
           DSUM=0.0
           ESUM=0.0
           AASUM=0.0
           BBSUM=0.0
           CCSUM=0.0
           DDSUM=0.0
           EESUM=0.0
           DO 11 I=1,NOBS
           ASUM=ASUM+XSAVE(I,1,1)
           BSUM=BSUM+XSAVE(I,1,1)**2
           CSUM=CSUM+XSAVE(I,2,1)
           DSUM=DSUM+XSAVE(I,2,1)**2
           ESUM=ESUM+XSAVE(I,1,1)*XSAVE(I,2,1)
           AASUM=AASUM+SSAVE(I,1,1)
           BBSUM=BBSUM+SSAVE(I,1,1)**2
           CCSUM=CCSUM+XSAVE(I,2,1)
           DDSUM=DDSUM+XSAVE(I,2,1)**2
  11       EESUM=EESUM+SSAVE(I,1,1)*XSAVE(I,2,1)
           XNOBS=FLOAT(NOBS)
           AA=XNOBS*ESUM-ASUM*CSUM
           BB=XNOBS*BSUM-ASUM*ASUM
           CC=XNOBS*DSUM-CSUM*CSUM
           DD=DSUM*ASUM-CSUM*ESUM
           ALP(1)=DD/CC
           BTA(1)=AA/CC
           RR(1)=AA/SQRT(BB*CC)
           RR(1)=RR(1)*RR(1)
           AA=XNOBS*EESUM-AASUM*CCSUM
           BB=XNOBS*BBSUM-AASUM*AASUM
           CC=XNOBS*DDSUM-CCSUM*CCSUM
           DD=DDSUM*AASUM-CCSUM*EESUM
           ALP(2)=DD/CC
           BTA(2)=AA/CC
           RR(2)=AA/SQRT(BB*CC)
           RR(2)=RR(2)*RR(2)
           WRITE(JIO,9090)KHR,RR(1),RR(2)
      ENDIF
C
C  CALCULATE CORRELATION OVER ALL PARAMETERS
C
      IF(KHR.EQ.0)THEN
           AASUM=0.0
           BBSUM=0.0
           CCSUM=0.0
           DDSUM=0.0
           EESUM=0.0
           ASUM=0.0
           BSUM=0.0
           CSUM=0.0
           DSUM=0.0
           ESUM=0.0
           DO 21 I=1,NOBS
           ASUM=ASUM+XSAVE(I,1,1)
           BSUM=BSUM+XSAVE(I,1,1)**2
           CSUM=CSUM+XSAVE(I,2,1)
           DSUM=DSUM+XSAVE(I,2,1)**2
  21       ESUM=ESUM+XSAVE(I,1,1)*XSAVE(I,2,1)
           DO 23 I=1,NRCALL
           ASUM=ASUM+ZSAVE(I,1,1)
           AASUM=AASUM+CSAVE(I,1)
           BSUM=BSUM+ZSAVE(I,1,1)**2
           BBSUM=BBSUM+CSAVE(I,1)**2
           CSUM=CSUM+ZSAVE(I,2,1)
           CCSUM=CCSUM+CSAVE(I,2)
           DSUM=DSUM+ZSAVE(I,2,1)**2
           DDSUM=DDSUM+CSAVE(I,2)**2
           EESUM=EESUM+CSAVE(I,1)*CSAVE(I,2)
           ESUM=ESUM+ZSAVE(I,1,1)*ZSAVE(I,2,1)
  23       CONTINUE
           ASUM=ASUM+AASUM
           BSUM=BSUM+BBSUM
           CSUM=CSUM+CCSUM
           DSUM=DSUM+DDSUM
           ESUM=ESUM+EESUM
           XCALL=FLOAT(NOBS+2*NRCALL)
           AA=XCALL*ESUM-ASUM*CSUM
           BB=XCALL*BSUM-ASUM*ASUM
           CC=XCALL*DSUM-CSUM*CSUM
           DD=DSUM*ASUM-CSUM*ESUM
           ALP(1)=DD/CC
           BTA(1)=AA/CC
           RR(1)=AA/SQRT(ABS(BB*CC))
           RR(1)=RR(1)*RR(1)
      ENDIF
      RETURN
      END
C
C ****************************************************************************
C  SUBROUTINE CLEAN----CALLED BY MAIN.  THROWS OUT ALL ROLLCALLS BELOW A
C     CUTOFF POINT (XVMIN)--USUALLY .05 OR .025.  THROWS OUT ALL LEGISLATORS
C     WHO HAVE VOTED KVMIN TIMES OR LESS (KVMIN=10 USUALLY).  KNAME(,)--
C     CHARACTER ARRAY HOLDING INFORMATION ON LEGISLATORS IS REARRANGED TO
C     HOLD ONLY INCLUDED LEGISLATORS.  LDATA( , ) IS THEN FILLED WITH THE
C     INCLUDED ROLL CALL VOTES.
C ****************************************************************************
C
      SUBROUTINE CLEAN(XVMIN,KVMIN)
      DIMENSION KKSUM(1601),LLSUM(1601),MMSUM(513),NNSUM(513),KD(1601)
      character*1 kname,KNAM2
      COMMON /XXCOM/ ZMID(1601),XDATA(513),DYN(1601),ldata(501,601),
     CUCUT(501),UINC(501),XINC(1601)
      COMMON /MINE/ NS,NQ,NRCALL,NSTEP,NEQ,ISENS(1000),
     CJAN,JANLST,JIO,KIO,NOBS,NOPAR,IFDRV,NFEVAL,
     CMAXIT,MAXSQZ,KNOL,KSTRT
      COMMON /VOTES/ KAV(1601),kay(1601),kan(1601),kname(513,25),
     CKNAM2(500,25),jne
      COMMON /TCHOIC/ KPTSUM
      DATA KKSUM,LLSUM/1601*0,1601*0/
      REWIND 20
      KPTSUM=0
      NAS=0
      NRS=0
      NOB=0
      NMOB=0
      DO 1 I=1,NOBS
      ISUM=0
      JSUM=0
      READ(20)(KD(J),J=1,NRCALL)
      DO 2 J=1,NRCALL
      IF(KD(J).EQ.1.OR.KD(J).EQ.2.OR.KD(J).EQ.3)KKSUM(J)=KKSUM(J)+1
      IF(KD(J).EQ.1.OR.KD(J).EQ.2.OR.KD(J).EQ.3)ISUM=ISUM+1
      IF(KD(J).EQ.4.OR.KD(J).EQ.5.OR.KD(J).EQ.6)LLSUM(J)=LLSUM(J)+1
  2   IF(KD(J).EQ.4.OR.KD(J).EQ.5.OR.KD(J).EQ.6)JSUM=JSUM+1
      MMSUM(I)=ISUM
  1   NNSUM(I)=JSUM
      REWIND 20
      DO 3 I=1,NOBS
      READ(20)(KD(J),J=1,NRCALL)
      LL=MMSUM(I)+NNSUM(I)
      IF(LL.GT.KVMIN)NOB=NOB+1
      IF(LL.LE.KVMIN)NMOB=NMOB+1
      IF(LL.LE.KVMIN)GO TO 3
      do 333 ij=1,jne
  333 kname(nob,ij)=kname(i,ij)
      NAS=0
      NRS=0
      DO 33 J=1,NRCALL
      KK=KKSUM(J)+LLSUM(J)
      LL=MIN0(KKSUM(J),LLSUM(J))
      AA=FLOAT(LL)/FLOAT(KK)
      IF(AA.GT.XVMIN)NAS=NAS+1
      IF(AA.LE.XVMIN)NRS=NRS+1
      IF(AA.GT.XVMIN)KAV(NAS)=J
      IF(AA.GT.XVMIN)KAY(NAS)=KKSUM(J)
      IF(AA.GT.XVMIN)KAN(NAS)=LLSUM(J)
      IF(AA.LE.XVMIN)GO TO 33
      IF(KD(J).EQ.2.OR.KD(J).EQ.3)KD(J)=1
      IF(KD(J).EQ.4.OR.KD(J).EQ.5)KD(J)=6
      IF(KD(J).EQ.7.OR.KD(J).EQ.8.OR.KD(J).EQ.9)KD(J)=0
      LDATA(NOB,NAS)=KD(J)
      if(kd(j).ne.0)kptsum=kptsum+1
 33   CONTINUE
  3   CONTINUE
      WRITE(KIO,1000)NRCALL,NRS,NAS,XVMIN
 1000 FORMAT(' NUMBER ROLL-CALLS READ=',I4,2X,'NUMBER REJECTED=',I4,2X,
     C'NUMBER ACCEPTED=',I4,2X,'CUTOFF=',F5.2)
      WRITE(KIO,1001)NOBS,NMOB,NOB,KVMIN
 1001 FORMAT(' NUMBER SENATORS READ=',I4,2X,'NUMBER REJECTED=',I4,2X,
     C'NUMBER ACCEPTED=',I4,2X,'CUTOFF=',I4)
      NRCALL=NAS
      NOBS=NOB
      RETURN
      END
C
C  ***********************************************************************
C    SUBROUTINE BLACKB---CALLED BY MAIN.  GENERATES STARTING COORDINATES
C      FOR LEGISLATORS BY PERFORMING PSEUDO SINGULAR VALUE DECOMPOSITION
C      OF THE FIRST NP (#OF LEGISLATORS) BY NY (=50) ROLL CALL SUBMATRIX.
C      THE NY ROLL CALLS ARE A SAMPLE FROM THE COMPLETE ROLL CALL MATRIX.
C      
C      PERFORMS THE FOLLOWING DECOMPOSITION:
C
C           X = [PW' + Jc'] + E
C         
C          WHERE X IS NPxNY, P IS NPxNF, W IS NYxNF, J IS A NP LENGTH
C            VECTORS OF 1'S, c IS A NY VECTOR OF CONSTANTS,
C            AND E IS NPxNY MATRIX OF ERROR WHICH IS MINIMIZED
C
C     THE MATRIX P (PSI BELOW) BECOMES THE STARTING COORDINATES FOR 
C       THE LEGISLATORS
C  ***********************************************************************
C  

      SUBROUTINE BLACKB(NP,NY,NF,NFX,KKIO,NRCALL)
      DIMENSION X(513,152),XX(208),FAL1(152),FAL2(152),
     CPSI(513,152),XS(513,152),LL(152),W(152,12,12),
     CSQU(152),R(152,152),D(152),WK(500),ROOTC(152,152),CROOT(152,152),
     CDD(152),DC(152),CC(152),XT(513,152),XSS(513,152),
     CMPOS(152),TSUM(208),DDD(152)
      COMMON /AREA1/ JR,LR
      COMMON /XXCOM/ ZMID(1601),XDATA(513),DYN(1601),ldata(501,601),
     CUCUT(501),UINC(501),XINC(1601)
      COMMON /XSREG/ AREG,BREG
      DATA DC,CC/152*0.0,152*0.0/
      DATA LL/152*0/
  23  FORMAT(' CORRELATION MATRIX FOR PSI')
  70  FORMAT(' ITERATION RECORD'/3X,'DIM',5X,'ERROR',5X,'EXPLAINED',
     C6X,'PERCENT',2X,'CUM PERCENT',3X,'R-SQUARE')
  86  FORMAT(' SINGULAR VALUES OF INPUT AND REPRODUCED MATRICES')
  113 FORMAT(1X,I5,8F12.4)
  300 FORMAT(' N OF CASES=',I4,1X,'TOTAL DATA=',I6,1X,
     C'N MISS=',I5,1X,'% MISS=',F6.3,1X,'SSE=',E12.5)
  335 FORMAT(' CORRECTION ROW=',I3,1X,' # POSITIVE=',I5)
  336 FORMAT(1X,25I3/1X,25I3)
  521 FORMAT(' cross PRODUCT MATRIX FOR PSI')
 1113 FORMAT(I3,12F8.3)
 2222 FORMAT(1X,78('.'))
 7200 FORMAT(' ERROR PARAMETER EIGENVALUE ROUTINE=',I4)
 9011 FORMAT(I5,3F10.4)
      KINK=(NRCALL-1)/NY
      KINKY=KINK*NY+1
      IF(NY.GT.NRCALL)THEN
         KINK=1
         KINKY=NY
      ENDIF
      JR=KKIO
      LR=JR
      NF1=NF+1
      DO 349 J=1,NY
      DC(J)=0.0
      CC(J)=0.0
  349 LL(J)=0.0
      KTOT=0
      SVSUM=0.0
      SWSUM=0.0
      WRITE(JR,2222)
C
C  DRAW SAMPLE OF NY ROLL CALLS FROM LDATA(NOBS , NRCALL)
C     PLACE IN X(NOBS,NY)=XS(NOBS,NY)=XSS(NOBS,NY)
C
      DO 600 I=1,NP
      SUM=0.0
      SUMA=0.0
      KK=0
      J=1
      DO 30 JJ=1,KINKY,KINK
      IF(J.GT.NY)GO TO 3030
      X(I,J)=FLOAT(LDATA(I,JJ))
C      IF(X(I,J).EQ.0.0)X(I,J)=9.0
      IF(X(I,J).NE.9.0)SUM=SUM+X(I,J)*X(I,J)
      IF(X(I,J).NE.9.0)SUMA=SUMA+X(I,J)
      IF(X(I,J).NE.9.0)KK=KK+1
      XS(I,J)=X(I,J)
  30  J=J+1
 3030 NY=J-1
      KTOT=KTOT+KK
      SVSUM=SVSUM+SUM
      SWSUM=SWSUM+SUMA
c
      write(jr,301)i,suma,sum,swsum,svsum
  301 format(i4,4f10.4)
c
      DO 31 J=1,NY
      XSS(I,J)=X(I,J)
      IF(X(I,J).EQ.9.0)GO TO 31
      LL(J)=LL(J)+1
      DC(J)=DC(J)+X(I,J)
      CC(J)=CC(J)+X(I,J)*X(I,J)
  31  CONTINUE
  600 CONTINUE
C
C   COMPUTE NY COLUMN MEANS PLACE IN DC(NY), COMPUTE SUM OF SQUARES
C     AND PERCENT MISSING DATA
C
      SVSUM=SVSUM-(SWSUM**2)/FLOAT(KTOT)
      LTOT=NP*NY
      PMISS=FLOAT(LTOT-KTOT)/FLOAT(LTOT)
      LTOT=LTOT-KTOT
      WRITE(JR,300)NP,KTOT,LTOT,PMISS,SVSUM
      DO 32 J=1,NY
      D(J)=CC(J)-(DC(J)*DC(J))/FLOAT(LL(J))
      DC(J)=DC(J)/FLOAT(LL(J))
  32  CONTINUE
C
C  COMPUTE CORRELATION NY BY NY CORRELATION MATRIX AND VECTOR OF SIGN
C    CHANGES FOR COLUMNS OF X/XS/XSS
C
      call CORR2(NP,NY,X,R,LL,MPOS,KS,KPOS,1)
C
C  MASTER LOOP FOR NF DIMENSIONS--ONE DIMENSION IS EXTRACTED AT A TIME.
C     THE RESIDUAL MATRIX IS COMPUTED AFTER EACH DIMENSION IS EXTRACTED
C     AND IT IS USED AS X IN THE FORMULA BELOW.  AT THE END OF THIS
C     PROCESS:
C
C              P'P = I, WITH P BEING NOBSxNF, W NYxNF, c NYx1
C
C           X = [PW' + Jc'] + E
C
      DO 9999 JJJ=1,NF
      KKK=JJJ
      WRITE(LR,335)KS,KPOS
      WRITE(LR,336)(LL(J),J=1,NY)
      WRITE(LR,336)(MPOS(J),J=1,NY)
      DO 10 J=1,NY
      XX(J)=1.0
      XX(J+NY)=-DC(J)
      IF(JJJ.GT.1)XX(J+NY)=0.0
  10  CONTINUE
      XXK=0.0
      TXB=0.0
      KKT=0
C
C  AT FIRST ITERATION JJJ = 1 THE COLUMN MEANS ARE SUBTRACTED
C     FOR SUBSEQUENT ITERATIONS, COLUMN MEANS = 0.  NOTE USE OF
C     COLUMN SIGN CHANGES (LL(NY)) FROM CORR2
C
      DO 3 I=1,NP
      KK=0
      SUM=0.0
      DO 1 J=1,NY
      IF(X(I,J).EQ.9.0)GO TO 1
      SUM=SUM+(X(I,J)*XX(J)+XX(J+NY))*FLOAT(LL(J))
      KK=KK+1
  1   CONTINUE
C
C  XT(NOBS,1) = (X - COL. MEAN)xSIGN CHANGE, SUMMED OVER ITH ROW--THIS
C     IS THE STARTING ESTIMATE OF THE FIRST COLUMN OF P (PSI BELOW).
C     THE MEAN OF XT(NOBS,1) IS THEN SUBTRACTED OUT BELOW SO THAT THE
C     STARTING ESTIMATE SUMS TO ZERO.
C     XT(NOBS,2) = 1 FOR THE LINEAR REGRESSIONS BELOW---TO PICK UP THE
C       INTERCEPT VECTOR, c
C
      IF(KK.LT.NFX)GO TO 3
      WXB=SUM/(FLOAT(KK))
      KKT=KKT+1
      TXB=TXB+WXB
      XT(I,1)=WXB
      XXK=XXK+XT(I,1)*XT(I,1)
  3   CONTINUE
      TXB=TXB/FLOAT(KKT)
      XXK=XXK-FLOAT(KKT)*TXB*TXB
      DO 40 I=1,NP
      IF(XT(I,1).EQ.9.0)GO TO 40
      XT(I,1)=(XT(I,1)-TXB)
      XT(I,2)=1.0
  40  CONTINUE
C
C  ALTERNATING LEAST SQUARES IS NOW PERFORMED TO FIRST ESTIMATE W AND c--
C    SUBROUTINE REG--ESTIMATES OF W AND c ARE RETURNED IN W(NY,NF+1,1)
C  W AND c ARE THEN USED TO ESTIMATE P IN SUBROUTINE REG2--
C  RESIDUALS ARE RETURNED IN X(NOBS,NY)
C
      DO 444 MM=1,4
      call REG(NP,1,NY,TSUM,W,XS,X,XT,1,1,KKK)
      call REG2(NP,1,NY,W,XS,X,XT,SQU,PXB,PXS,KKK)
C
C  PXB IS THE MEAN OF THE ESTIMATED COLUMN OF P
C  PXS IS THE VARIANCE OF THE ESTIMATED COLUMN OF P
C
      QXS=PXS
      XCOR=SQRT(XXK/PXS)
      WRITE(JR,113)MM,XXK,QXS,PXS,XCOR,PXB,TXB
      DO 444 I=1,NP
      IF(XT(I,1).EQ.9.0)PSI(I,JJJ)=9.0
      IF(PSI(I,JJJ).EQ.9.0)GO TO 444
C
C  THE ESTIMATED MEAN, PXB, IS SUBTRACTED OFF AND THE COLUMN IS
C    ADJUSTED SO IT HAS THE ORIGINAL SUM OF SQUARES WITH MEAN ZERO
C
      PSI(I,JJJ)=(XT(I,1)-PXB)*XCOR
      XT(I,1)=(XT(I,1)-PXB)*XCOR
  444 CONTINUE
C
C  END OF A.L.S. LOOP
C
C  IF THIS IS THE LAST ITERATION, I.E. JJJ = NF, THEN PUT A VECTOR
C    OF ONES INTO THE NF+1 COLUMN OF THE ESTIMATED P MATRIX
C    AND RESET X(NOBS,NY)--WHICH STARTED AS THE ORIGINAL DATA AND
C    THEN BECAME THE RESIDUAL MATRIX AT EACH STAGE--BACK TO THE
C    ORIGINAL DATA WHICH WAS SAVED IN XSS(NOBS,NY)
C
C  IF THIS IS NOT THE LAST ITERATION, PUT THE RESIDUALS X(NOBS,NY) INTO
C    XS(NOBS,NY), AND CALL CORR2 TO GET THE SIGN CHANGES FOR THE COLUMNS
C    WHICH ARE USED ABOVE
C
      DO 461 I=1,NP
      IF(KKK.EQ.NF)PSI(I,NF+1)=1.0
      DO 461 J=1,NY
      IF(KKK.EQ.NF)X(I,J)=XSS(I,J)
  461 XS(I,J)=X(I,J)
      IF(KKK.EQ.NF)GO TO 9999
      call CORR2(NP,NY,X,R,LL,MPOS,KS,KPOS,1)
 9999 CONTINUE
C
C  WRITE OUT CORRELATION AND CROSS PRODUCT MATRIX OF P
C
      WRITE(JR,23)
      call CORR2(NP,NF,PSI,R,LL,MPOS,KS,KPOS,0)
      WRITE(LR,521)
      call PSIPRM(NP,NF1,PSI)
C
C  PERFORM A.L.S. WITH FULL P MATRIX UNTIL CONVERGENCE
C
      DO 222 NN=1,5
      call REG(NP,NF,NY,TSUM,W,XS,X,PSI,1,1,NF)
      call REG2(NP,NF,NY,W,XS,X,PSI,SQU,PXB,PXS,NF)
      AA=ABS(AREG-BREG)
      IF(AA.LT..01)GO TO 223
  222 CONTINUE
  223 NFPS=NF+1
C
C  COMPUTE PW' + Jc' AND PUT INTO X(NOBS,NY)
C  FOR MISSING DATA, INSERT ESTIMATED VALUES IN X INTO THE 
C    ORIGINAL DATA MATRIX USING XT(NOBS,NY) SO THAT SINGULAR VALUES
C    CAN BE ESTRACTED FROM ORIGINAL DATA
C
      DO 60 I=1,NP
      IF(PSI(I,1).EQ.9.0)GO TO 60
      DO 61 K=1,NY
      WK(K)=0.0
      SUM=0.0
      DO 62 J=1,NFPS
  62  SUM=SUM+PSI(I,J)*W(K,J,NF)
  61  X(I,K)=SUM
      DO 59 JJ=1,NY
      IF(XS(I,JJ).NE.9.0)XT(I,JJ)=XS(I,JJ)
      IF(XS(I,JJ).EQ.9.0)XT(I,JJ)=X(I,JJ)
  59  CONTINUE
  60  CONTINUE
C
C  EXTRACT SINGULAR VALUES FROM ORIGINAL DATA MATRIX WITH ESTIMATES
C   INSERTED FOR MISSING DATA
C
      DO 71 I=1,NY
      DO 71 J=1,NY
      SUM=0.0
      DO 73 K=1,NP
  73  SUM=SUM+XT(K,I)*XT(K,J)
  71  ROOTC(I,J)=SUM
      CALL RS(152,NY,ROOTC,D,1,CROOT,FAL1,FAL2,IERR)
      WRITE(JR,7200)IERR
      ESUM=0.0
      SUMM=0.0
      SUMM1=0.0
      SUMM2=0.0
      DO 83 I=1,NP
      DO 83 J=1,NY
      SUMM=SUMM+X(I,J)**2
      IF(XS(I,J).NE.9.0)ESUM=ESUM+(X(I,J)-XS(I,J))**2
      IF(XS(I,J).NE.9.0)SUMM1=SUMM1+X(I,J)**2
      IF(XS(I,J).EQ.9.0)SUMM2=SUMM2+X(I,J)**2
C
C  STORE PW' + Jc' IN XSS(NOBS,NY) AND COMPUTE PW' AND STORE IN XT(NOBS,NY)
C
      XSS(I,J)=X(I,J)
  83  XT(I,J)=X(I,J)-W(J,NF+1,NF)
C
C  PERFORM SINGULAR VALUE DECOMPOSITION OF PW' + Jc'
C
      DO 75 I=1,NY
      DO 75 J=1,NY
      SUM=0.0
      DO 76 K=1,NP
  76  SUM=SUM+XSS(K,I)*XSS(K,J)
  75  ROOTC(I,J)=SUM
      CALL RS(152,NY,ROOTC,DDD,1,CROOT,FAL1,FAL2,IERR)
      WRITE(JR,7200)IERR
C
C  PERFORM SINGULAR VALUE DECOMPOSITION OF PW'
C
      DO 77 I=1,NY
      DO 77 J=1,NY
      SUM=0.0
      DO 78 K=1,NP
  78  SUM=SUM+XT(K,I)*XT(K,J)
  77  ROOTC(I,J)=SUM
      CALL RS(152,NY,ROOTC,DD,1,CROOT,FAL1,FAL2,IERR)
      WRITE(JR,7200)IERR
C
C  WRITE OUT SINGULAR VALUES FOR ORIGINAL DATA (USING ESTIMATES FOR
C   MISSING ENTRIES), PW' + Jc', AND PW'
C
      SUM=0.0
      BSUM=0.0
      DO 85 J=1,NY
      D(J)=SQRT(ABS(D(J)))
      DD(J)=SQRT(ABS(DD(J)))
      DDD(J)=SQRT(ABS(DDD(J)))
      BSUM=BSUM+DDD(J)
  85  SUM=SUM+D(J)
      WRITE(JR,86)
      BB=0.0
      BBBB=0.0
      DO 87 J=1,NY
      AA=D(NY+1-J)/SUM
      AAAA=DDD(NY+1-J)/BSUM
      BBBB=BBBB+AAAA
      BB=BB+AA
      WK(J)=0.0
      WK(J+NY)=0.0
      IF(J.GT.5)GO TO 87
      WRITE(JR,1113)J,D(NY+1-J),AA,BB,DDD(NY+1-J),AAAA,BBBB,
     CDD(NY+1-J)
  87  CONTINUE
C
C  COMPUTE STARTING ESTIMATE OF LEGISLATOR COORDINATES AS
C      XDATA(NOBS,NF) = P*(NOBS,NF) , WHERE
C      P*P*' = PW'WP'
C
C    ****NOTE THAT P* IS NOBSxNY, BUT ONLY FIRST NF COLUMNS USED
D        AS THE STARTS****
C
      DO 91 I=1,NP
      IF(PSI(I,1).EQ.9.0)GO TO 91
      DO 90 K=1,NY
      SUM=0.0
      DO 89 J=1,NY
      AZULU=SQRT(DD(NY+1-K))
      BZULU=0.0
      IF(AZULU.GT..1)BZULU=1.0/AZULU
  89  SUM=SUM+(X(I,J)-W(J,NF+1,NF))*CROOT(J,NY+1-K)*BZULU
      WK(K)=WK(K)+SUM*SUM
      WK(K+NY)=WK(K+NY)+SUM
  90  PSI(I,K)=SUM
      DO 525 JJ=1,NF
      XDATA(I)=PSI(I,JJ)
  525 CONTINUE
      WRITE(23,9011)I,(PSI(I,JROOT),JROOT=1,3)
  91  CONTINUE
C
C  COMPUTE COLUMN MEANS OF P*
C
      DO 92 J=1,NY
      WK(J+NY)=WK(J+NY)/FLOAT(NP)
  92  CONTINUE
C
C  WRITE OUT CORRELATION MATRIX OF P*
C
      WRITE(JR,23)
      call CORR2(NP,NF,PSI,R,LL,MPOS,KS,KPOS,0)
C
C  SUBTRACT OFF COLUMN MEANS FROM P* AND CONSTRUCT PARTITIONED
C    MATRIX PSI[1 | XDATA].  IN SUBROUTINE REG BELOW, THIS ALLOWS
C    A REGRESSION ON THE FIRST DIMENSION, THEN THE FIRST AND SECOND,
C    THEN THE FIRST, SECOND, AND THIRD, AND SO ON SO THAT THE SS
C    ACCOUNTED FOR BY EACH DIMENSION CAN BE COMPUTED AND STORED IN
C    TSUM WHICH IS PRINTED OUT BELOW
C
      DO 63 I=1,NP
      DO 636 J=1,NY
      IF(PSI(I,1).EQ.9.0)GO TO 636
      PSI(I,J)=PSI(I,J)-WK(J+NY)
  636 CONTINUE
      IF(PSI(I,1).EQ.9.0)GO TO 63
      DO 666 JJ=1,NF
  666 PSI(I,NF+2-JJ)=PSI(I,NF+1-JJ)
      PSI(I,1)=1.0
  63  CONTINUE
C
C  WRITE OUT [1 | XDATA]'[1 | XDATA]
C
      WRITE(LR,521)
      call PSIPRM(NP,NF1,PSI)
C 
C  CALL REG TO COMPUTE SS ACROSS THE ESTIMATED NF DIMENSIONS
C
      call REG(NP,NF,NY,TSUM,W,XS,X,PSI,0,0,KKK)
C
C  WRITE OUT SS ACROSS NF ESTIMATED DIMENSIONS
C
      WRITE(JR,70)
      DO 69 J=1,NF
      AA=(SVSUM-TSUM(J))/SVSUM
      CCC=SVSUM-TSUM(J)
      IF(J.EQ.1)BB=SVSUM
      IF(J.GT.1)BB=TSUM(J-1)
      SUM=(BB-TSUM(J))/SVSUM
  69  WRITE(JR,113)J,TSUM(J),CCC,SUM,AA,TSUM(J+NY)
      WRITE(JR,2222)
      RETURN
      END
C
C  **********************************************************************
C    SUBROUTINE CORR2---CALLED BY BLACKB.  COMPUTES CORRELATION MATRIX
C     FOR INPUT MATRIX X AND COMPUTES THE VECTOR OF COLUMN SIGN CHANGES
C     WHICH IS STORED IN VECTOR LL.
C  **********************************************************************
C
      SUBROUTINE CORR2(NP,NY,X,R,LL,MPOS,KS,KPOS,IPRNT)
      DIMENSION X(513,152),R(152,152),SA(152,152),SB(152,152),
     CSD(152,152),LL(152),MPOS(152),SC(152,152)
      COMMON /AREA1/ JR,LR
  200 FORMAT(1X,50F7.3)
      DO 1 J=1,NY
      DO 1 JJ=1,NY
      SA(J,JJ)=0.0
      SB(J,JJ)=0.0
      SC(J,JJ)=0.0
  1   SD(J,JJ)=0.0
      DO 40 I=1,NP
      DO 31 J=1,NY
      DO 31 JJ=1,J
      IF(X(I,J).EQ.9.0)GO TO 31
      IF(X(I,JJ).EQ.9.0)GO TO 31
      SA(J,JJ)=SA(J,JJ)+X(I,J)
      IF(J.NE.JJ)SA(JJ,J)=SA(JJ,J)+X(I,JJ)
      SB(J,JJ)=SB(J,JJ)+X(I,J)*X(I,J)
      IF(J.NE.JJ)SB(JJ,J)=SB(JJ,J)+X(I,JJ)*X(I,JJ)
      SC(J,JJ)=SC(J,JJ)+X(I,J)*X(I,JJ)
      SC(JJ,J)=SC(J,JJ)
      SD(J,JJ)=SD(J,JJ)+1.0
  31  CONTINUE
  40  CONTINUE
      DO 32 J=1,NY
      DO 32 JJ=1,J
      AA=SD(J,JJ)*SC(J,JJ)-SA(J,JJ)*SA(JJ,J)
      BB=SD(J,JJ)*SB(J,JJ)-SA(J,JJ)*SA(J,JJ)
      CC=SD(J,JJ)*SB(JJ,J)-SA(JJ,J)*SA(JJ,J)
      BBCC=BB*CC
      IF(BBCC.LE..0)R(JJ,J)=0.0
      IF(BBCC.LE..0)GO TO 343
      R(JJ,J)=AA/SQRT(BB*CC)
  343 CONTINUE
  32  R(J,JJ)=R(JJ,J)
      IF(IPRNT.EQ.1)GO TO 62
      DO 34 J=1,NY
  34  WRITE(JR,200)(R(J,JJ),JJ=1,NY)
  62  BB=-99.0
C
C  FIND ROW WITH LARGEST TOTAL SUM OF ABSOLUTE VALUED CORRELATIONS
C
      KS=0
      DO 50 J=1,NY
      SUM=0.0
      DO 51 JJ=1,NY
  51  SUM=SUM+ABS(R(J,JJ))
      BB=AMAX1(SUM,BB)
      IF(BB.EQ.SUM)KS=J
  50  CONTINUE
      DO 52 J=1,NY
      IF(R(KS,J).LE.0.0)LL(J)=-1
  52  IF(R(KS,J).GT.0.0)LL(J)=1
C
C  ITERATIVELY CHANGE SIGNS OF COLUMNS TO MAXIMIZE NUMBER OF ENTRIES
C   IN THE CORRELATION MATRIX WHICH ARE POSITIVE.  THIS VECTOR IS THEN
C   RETURNED AS THE SIGN CHANGES FOR THE DATA MATRIX X.
C
      NYD2=(NY-1)/2
      KPOS=0
      DO 60 JK=1,NY
      DO 60 J=1,NY
      KK=0
      KSUM=0
      DO 61 JJ=1,NY
      AA=R(J,JJ)*FLOAT(LL(JJ))*FLOAT(LL(J))
      IF(JK.EQ.NY.AND.AA.GE.0.0)KPOS=KPOS+1
      IF(JK.EQ.NY.AND.AA.GE.0.0)KSUM=KSUM+1
  61  IF(AA.LT.0.0)KK=KK+1
      IF(KK.GT.NYD2)LL(J)=LL(J)*(-1)
      IF(JK.EQ.NY)MPOS(J)=KSUM
  60  IF(KK.GT.NYD2)KS=999
      RETURN
      END
C
C  ************************************************************************
C    SUBROUTINE REG---CALLED BY BLACKB.  PERFORMS REGRESSION TO ESTIMATE
C      W AND c.
C  ************************************************************************
C
      SUBROUTINE REG(NP,NF,NY,TSUM,W,XS,X,PSI,IPRNT,ILAST,KKK)
      DIMENSION XS(513,152),PSI(513,152),A(12,12),B(12,12),FV2(12),
     CW(152,12,12),C(152),TSUM(208),X(513,152),LLL(152),FV1(12),
     CXT(513,152),R(152,152),LL(152),RSUM(152),MPOS(152),WVEC(12),
     CZMAT(12,12)
      COMMON /AREA1/ JR,LR
      COMMON /XSREG/ AREG,BREG
  100 FORMAT(' PERFORMANCE INDEX MATRIX INVERSE=',2I5)
  101 FORMAT(' PERFORMANCE INDEX EIGENVALUE/VECTOR ROUTINE=',I5)
  111 FORMAT(1X,8A1,13F10.4)
  200 FORMAT(3I5,15F10.4)
  250 FORMAT(' DIMENSION=',I3,1X,'TOTAL SSE REG1=',F15.4)
  300 FORMAT(' SSE AND FINAL WEIGHT MATRIX')
      NF1=NF+1
      DO 15 K=1,NY
      LLL(K)=0
      TSUM(K)=0.0
      C(K)=0.0
      DO 15 KK=1,NF
      DO 15 J=1,NF1
  15  W(K,J,KK)=0.0
C
C  IF ILAST = 1 THEN ONLY PERFORM THE ESTIMATE OF W AND c FOR THE 
C   CURRENT COLUMN OF P.
C  IF ILAST = 0 THEN ESTIMATE W AND c ASSUMING NF=1, THEN ASSUMING
C   NF=2, UP TO NF=NF.  THIS ALLOWS THE COMPUTATION OF THE SS ACCOUNTED
C   FOR BY A 1 DIMENSION PW' + Jc' MODEL, A 2 DIMENSION PW' + Jc' MODEL,
C   AND SO ON.
C
      IF(ILAST.EQ.1)KKA=NF
      IF(ILAST.EQ.0)KKA=1
      DO 11 KK=KKA,NF
C
C  RUN REGRESSION TO ESTIMATE W AND c ONE COLUMN AT A TIME
C   BECAUSE OF MISSING DATA
C
      DO 7 K=1,NY
      LLL(K)=0
      NF1=KK+1
      NF11=KK+2
C
C  COMPUTE [P'P]-1
C
      DO 2 J=1,NF1
      DO 2 JJ=1,NF1
      SUM=0.0
      DO 1 I=1,NP
      IF(XS(I,K).EQ.9.0)GO TO 1
      IF(PSI(I,1).EQ.9.0)GO TO 1
      SUM=SUM+PSI(I,J)*PSI(I,JJ)
  1   CONTINUE
  2   A(J,JJ)=SUM
      call rs(12,nf1,a,wvec,1,ZMAT,fv1,fv2,ier)
      DO 60 I=1,NF1
      DO 60 KX=1,NF1
      SUM=0.0
      DO 61 J=1,NF1
  61  SUM=SUM+ZMAT(KX,J)*(1.0/WVEC(J))*ZMAT(I,J)
  60  B(I,KX)=SUM
C
C  COMPUTE [P'P]-1*P'X = W'/c'
C
      DO 3 I=1,NP
      IF(XS(I,K).EQ.9.0)GO TO 3
      IF(PSI(I,1).EQ.9.0)GO TO 3
      DO 5 J=1,NF1
      SUM=0.0
      DO 4 JJ=1,NF1
  4   SUM=SUM+B(J,JJ)*PSI(I,JJ)
  5   C(J)=SUM
      DO 6 J=1,NF1
  6   W(K,J,KK)=W(K,J,KK)+C(J)*XS(I,K)
  3   CONTINUE
C
C  CALCULATE R-SQUARE AND SSE FOR REGRESSION
C
      ESUM=0.0
      DO 8 I=1,NP
      XT(I,1)=9.0
      XT(I,2)=9.0
      IF(XS(I,K).EQ.9.0)GO TO 8
      IF(PSI(I,1).EQ.9.0)GO TO 8
      LLL(K)=LLL(K)+1
      SUM=0.0
      DO 9 J=1,NF1
  9   SUM=SUM+PSI(I,J)*W(K,J,KK)
      ESUM=ESUM+(SUM-XS(I,K))**2
      X(I,K)=SUM-XS(I,K)
      XT(I,1)=SUM
      XT(I,2)=XS(I,K)
  8   CONTINUE
      W(K,NF11,KK)=ESUM
      TSUM(KK)=TSUM(KK)+ESUM
      call CORR2(NP,2,XT,R,LL,MPOS,KS,KPOS,1)
      RSUM(K)=R(1,2)*R(1,2)
  7   CONTINUE
C
C  END OF REGRESSION LOOP FOR CURRENT DIMENSION
C
      IF(ILAST.EQ.1)GO TO 90
C
C  IF ILAST = 0 THEN CALCULATE THE R-SQUARE FOR THE CURRENT
C   NUMBER OF DIMENSIONS
C
      DO 88 I=1,NP
      DO 88 K=1,NY
      SUM=0.0
      DO 89 J=1,NF1
  89  SUM=SUM+PSI(I,J)*W(K,J,KK)
  88  XT(I,K)=SUM
      call RSQUR(NP,NY,RR,XT,XS)
      TSUM(KK+NY)=RR
  90  CONTINUE
      IF(IPRNT.EQ.1)GO TO 333
      WRITE(JR,300)
      DO 10 J=1,NY
  10  WRITE(LR,200)KK,J,LLL(J),W(J,NF11,KK),RSUM(J),(W(J,JJ,KK),JJ=1
     C,NF1)
  333 CONTINUE
      IF(ILAST.EQ.1)WRITE(JR,250)KKK,TSUM(KK)
      IF(ILAST.EQ.0)WRITE(JR,250)KK,TSUM(KK)
      AREG=TSUM(KK)
  11  CONTINUE
C
C  END OF DIMENSION ITERATION LOOP--ONLY IF ILAST = 0
C
      RETURN
      END
C
C  **************************************************************************
C    SUBROUTINE REG2---CALLED BY BLACKB.  PERFORMS REGRESSION TO ESTIMATE P.
C  **************************************************************************
C
      SUBROUTINE REG2(NP,NF,NY,W,XS,X,PSI,SQU,PXB,PXS,KKK)
      DIMENSION W(152,12,12),X(513,152),XS(513,152),PSI(513,152),
     CA(152,12),V(152),SQU(152),Y(152)
      COMMON /AREA1/ JR,LR
      COMMON /XSREG/ AREG,BREG
      NF1=NF+1
      ESUM=0.0
      PXB=0.0
      PXS=0.0
      XNS=0.0
C
C  REGRESS ONE ROW AT A TIME BECAUSE OF MISSING DATA
C
      DO 1 I=1,NP
      IF(PSI(I,1).EQ.9.0)GO TO 1
      KK=0
C
C  SET UP DEPENDENT VARIABLE-- Y(NY) = X[I,NY] - NY COL. MEANS
C    AND PUT W(NY,NF) INTO MATRIX A(NY,NF)
C
      DO 2 J=1,NY
      V(J)=0.0
      IF(XS(I,J).EQ.9.0)GO TO 2
      KK=KK+1
      Y(KK)=XS(I,J)-W(J,NF1,NF)
      DO 3 JJ=1,NF
  3   A(KK,JJ)=W(J,JJ,NF)
  2   CONTINUE
C
C  CALL SUBROUTINE REGA TO PERFORM LEAST SQUARES
C
      NS=KK
      call REGA(NS,NF,A,Y,V)
C
C  STORE ESTIMATED ROW ENTRIES OF P AND COMPUTE SSE
C
      DO 5 K=1,NY
      SUM=0.0
      IF(XS(I,K).EQ.9.0)GO TO 5
      DO 4 J=1,NF
      PSI(I,J)=V(J)
      SUM=SUM+PSI(I,J)*W(K,J,NF)
  4   CONTINUE
      SUM=SUM+W(K,NF1,NF)
      X(I,K)=SUM-XS(I,K)
      ESUM=ESUM+(SUM-XS(I,K))**2
  5   CONTINUE
      PXB=PXB+PSI(I,1)
      PXS=PXS+PSI(I,1)**2
      XNS=XNS+1.0
  1   CONTINUE
C
C  END OF REGRESSION LOOP
C
C  PXB IS THE SUM OF THE ESTIMATED COLUMN OF P AND
C  PXS IS THE VARIANCE OF THE ESTIMATED COLUMN OF P.
C  THESE ARE RETURNED TO BLACKB FOR ADJUSTMENT PURPOSES
C
      PXB=PXB/XNS
      PXS=PXS-XNS*PXB*PXB
      SQU(KKK)=ESUM
      WRITE(JR,350)KKK,ESUM
  350 FORMAT(' DIMENSION=',I3,1X,'TOTAL SSE REG2=',F15.4)
      BREG=ESUM
      RETURN
      END
C
C  **************************************************************************
C    SUBROUTINE REGA---CALLED BY REG2.  PERFORMS THE REGRESSION:
C
C         [W'W]-1*W'[X(I,NY) - c']
C
C      TO GET THE ROW ENTRIES OF P.
C  **************************************************************************
C
      SUBROUTINE REGA(NS,NF,A,Y,V)
      DIMENSION A(152,12),Y(152),B(12,12),C(12,12),V(152),
     CBB(12,152),ZMAT(12,12),FV1(12),FV2(12),WVEC(12)
      COMMON /AREA1/ JR,LR
  101 FORMAT(' PERFORMANCE INDEX EIGENVALUE/VECTOR ROUTINE=',I5)
      DO 1 J=1,NF
      DO 1 JJ=1,NF
      SUM=0.0
      DO 2 I=1,NS
  2   SUM=SUM+A(I,J)*A(I,JJ)
  1   B(J,JJ)=SUM
      call rs(12,nf,B,wvec,1,ZMAT,fv1,fv2,ier)
      DO 60 I=1,NF
      DO 60 K=1,NF
      SUM=0.0
      DO 61 J=1,NF
  61  SUM=SUM+ZMAT(K,J)*(1.0/WVEC(J))*ZMAT(I,J)
  60  C(I,K)=SUM
      DO 3 I=1,NS
      DO 3 J=1,NF
      SUM=0.0
      DO 4 JJ=1,NF
  4   SUM=SUM+C(J,JJ)*A(I,JJ)
  3   BB(J,I)=SUM
      DO 5 JJ=1,NF
      SUM=0.0
      DO 6 J=1,NS
  6   SUM=SUM+BB(JJ,J)*Y(J)
  5   V(JJ)=SUM
      RETURN
      END
C
C  ***************************************************************************
C    SUBROUTINE RSQUR---CALLED BY REG.  COMPUTES THE SIMPLE PEARSON R-SQUARE
C     BETWEEN TWO INPUT MATRICES---A(NOBS,NY) AND B(NOBS,NY)
C  ***************************************************************************
C
      SUBROUTINE RSQUR(NP,NY,R,A,B)
      DIMENSION A(513,152),B(513,152)
      COMMON /AREA1/ JR,LR
      ASUM=0.0
      BSUM=0.0
      CSUM=0.0
      DSUM=0.0
      ESUM=0.0
      XNT=0.0
      DO 1 I=1,NP
      DO 1 J=1,NY
      IF(A(I,J).EQ.9.0)GO TO 1
      IF(B(I,J).EQ.9.0)GO TO 1
      ASUM=ASUM+A(I,J)
      BSUM=BSUM+B(I,J)
      CSUM=CSUM+A(I,J)*A(I,J)
      DSUM=DSUM+B(I,J)*B(I,J)
      ESUM=ESUM+A(I,J)*B(I,J)
      XNT=XNT+1.0
  1   CONTINUE
      AA=XNT*ESUM-ASUM*BSUM
      BB=XNT*CSUM-ASUM*ASUM
      CC=XNT*DSUM-BSUM*BSUM
      R=(AA*AA)/(BB*CC)
      RETURN
      END
C
C  ***************************************************************************
C    SUBROUTINE PSIPRM---CALLED BY BLACKB.  CALCULATES P'P AND WRITES IT OUT.
C  ***************************************************************************
C
      SUBROUTINE PSIPRM(NP,NF,PSI)
      DIMENSION PSI(513,152),R(12,12)
      COMMON /AREA1/ JR,LR
  200 FORMAT(1X,50F10.4)
      DO 1 J=1,NF
      DO 1 K=1,NF
      SUM=0.0
      DO 2 I=1,NP
      IF(PSI(I,1).EQ.9.0)GO TO 2
      SUM=SUM+PSI(I,J)*PSI(I,K)
  2   CONTINUE
  1   R(J,K)=SUM
      DO 3 I=1,NF
  3   WRITE(LR,200)(R(I,J),J=1,NF)
      RETURN
      END
C
C  **************************************************************************
C     SUBROUTINE RECODE--CALLED BY MAIN.  GENERATES STARTING VALUES FOR THE
C       ROLL CALL PARAMETERS.
C  **************************************************************************
C
      SUBROUTINE RECODE(NOBS,NRCALL,KLSEN,KIO)
      DIMENSION X(513),KV(513),LL(513)
      character*1 kname,KNAM2
      COMMON /XXCOM/ ZMID(1601),XDATA(513),DYN(1601),ldata(501,601),
     CUCUT(501),UINC(501),XINC(1601)
      COMMON /SENMIN/ sss(100),KSMIN,KSMAX
      COMMON /VOTES/ KAV(1601),kay(1601),kan(1601),kname(513,25),
     CKNAM2(500,25),jne
      COMMON /SAVE/ XSAVE(513,8,2),ZSAVE(1601,8,2),CSAVE(1601,8),
     CQSAVE(1601,8,2),RSAVE(1601,8),SSAVE(513,8,2)
      COMMON /TCHOIC/ KPTSUM
      COMMON /BOOK/ BBB(50)
      COMMON /TITLE/ TIT2(26,3)
 2000 FORMAT(' NUMBER LEGISLATORS=',I4,1X,'FURTHEST LEFT=',F10.4,1X,
     C'FURTHEST RIGHT=',F10.4/' POSITIONS: LEFT=',I4,2X,'RIGHT=',I4)
      AA=99.0
      BB=-99.0
C
C  SET FURTHEST LEFT SENATOR TO NEGATIVE VALUE CHANGE SIGNS OF LEGISLATORS
C     IF NECESSARY AND FIND MAXIMUM AND MINIMUM LEGISLATORS
C
      XXX=XDATA(KLSEN)
      DO 1 I=1,NOBS
      IF(XXX.LT..0)GO TO 2
      XDATA(I)=-XDATA(I)
  2   AA=AMIN1(AA,XDATA(I))
      BB=AMAX1(BB,XDATA(I))
      IF(AA.EQ.XDATA(I))KSMIN=I
      IF(BB.EQ.XDATA(I))KSMAX=I
  1   CONTINUE
C
C  WRITE OUT MAXIMUM AND MINIMUM LEGISLATORS
C
      WRITE(KIO,2000)NOBS,AA,BB,KSMIN,KSMAX
C
C  TRANSFORM LEGISLATOR CONFIGURATION SO THAT IT RUNS FROM -1 TO +1
C
      AA=(XDATA(KSMIN)+XDATA(KSMAX))/2.0
      BB=XDATA(KSMAX)-AA
      DO 10 I=1,NOBS
      LL(I)=I
      XDATA(I)=(XDATA(I)-AA)/BB
      XSAVE(I,1,1)=XDATA(I)
  10  X(I)=XDATA(I)
      CALL RSORT(X,NOBS,LL)
C
C  STORE 4 MOST EXTREME LEGISLATORS IN SSS(.)
      SSS(1)=X(1)
      SSS(2)=X(NOBS)
      SSS(3)=X(2)
      sss(4)=X(NOBS-1)
C
C  CALL JANICE TO FIND OPTIMAL CUTTING LINE FOR EACH ROLL CALL AND
C    SET ZMID(.) TO THE OPTIMAL CUTTING LINE.  DETERMINE INITIAL
C    POLARITY OF ROLL CALL AND STORE -1.0 OR +1.0 IN DYN(.) DEPENDING
C    UPON POLARITY.
C
      KPTSUM=0
      DO 3 J=1,NRCALL
      SUMY=0.0
      SUMN=0.0
      DO 4 I=1,NOBS
      KV(I)=LDATA(LL(I),J)
      IF(LDATA(I,J).EQ.1)SUMY=SUMY+XDATA(I)
  4   IF(LDATA(I,J).EQ.6)SUMN=SUMN+XDATA(I)
      SUMY=SUMY/FLOAT(KAY(J))
      SUMN=SUMN/FLOAT(KAN(J))
      SUMM=(SUMN+SUMY)/2.0
      KYES=KAY(J)
      KNO=KAN(J)
      JJJJ=J
C
C  JANICE FINDS OPTIMAL CUTTING POINT AND POLARITY
C
      call JANICE(JJJJ,KAV,NOBS,KV,X,KYES,KNO,KIO,KFLIP,ZSAB,YPRE,SUMY,
     CSUMN,SUMM)
      DO 7 I=1,NOBS
      IF(LDATA(I,J).NE.0)KPTSUM=KPTSUM+1
  7   IF(LDATA(I,J).EQ.6)LDATA(I,J)=2
      ZMID(J)=ZSAB
      IF(ZSAB.GT.0.0)DT=(ZSAB+1.0)/2.0
      IF(ZSAB.LE.0.0)DT=(1.0-ZSAB)/2.0
      IF(KFLIP.EQ.1)DYN(J)=DT
      IF(KFLIP.EQ.2)DYN(J)=-DT
      ZSAVE(J,1,1)=DYN(J)
      CSAVE(J,1)=ZMID(J)
  33  CONTINUE
  3   CONTINUE
      RETURN
      END
C
C  ***************************************************************************
C    SUBROUTINE JANICE---CALLED BY RECODE.  SEARCHES EVERY PAIR OF ADJACENT
C      LEGISLATORS IN ASCENDING ORDER AND CALCULATES CLASSIFICATION ERROR
C      ASSOCIATED WITH USING THE MIDPOINT BETWEEN THE PAIR OF ADJACENT
C      LEGISLATORS AS THE ROLL CALL MIDPOINT.  THIS IS DONE FOR EACH POLARITY
C      OF THE ROLL CALL (LEFT = YES/RIGHT = YES).  PROGRAM RETURNS THE BEST
C      CUTPOINT AND POLARITY OF ROLL CALL.
C  ***************************************************************************
C
      SUBROUTINE JANICE(JJJJ,KAV,NS,KV,X,KYES,KNO,JP,KFLIP,ZSAB,YPRE,
     CSUMY,SUMN,SUMM)
      COMMON/ INTGER /IIII
      DIMENSION KV(513),X(513),Y(513),Z(513),LV(513),LVB(513),LE(513),
     CLEB(513),WK(10),KAV(1601)
  200 FORMAT('         KYES KNO   ZM   #ZM  CH  CL  EH  EL    %      PRE
     C    YES    NO    MID')
  250 FORMAT(1X,4I4,F7.3,5I4,5F7.3)
  260 FORMAT(17X,F7.3,5I4,2F7.3)
      NSS=NS-1
      KCUT=1
      LCUT=6
      DO 999 III=1,2
      IF(III.EQ.2)KCUT=6
      IF(III.EQ.2)LCUT=1
      IF(IIII.GT.1)KCUT=2
      IF(IIII.GT.1)LCUT=1
      KMARK=1
      KSE=0
      KSV=0
      LSV=0
      LSE=0
      I=0
  10  I=I+1
      IF(I.EQ.NS)GO TO 12
      IF(I.LT.NS)Y(I)=(X(I)+X(I+1))/2.0
      IF(KV(I).EQ.KCUT)KSV=KSV+1
      IF(KV(I).EQ.LCUT)KSE=KSE+1
      IF(KMARK.EQ.1)GO TO 30
      IF(KV(I).EQ.KCUT)LSE=LSE-1
      IF(KV(I).EQ.LCUT)LSV=LSV-1
      GO TO 31
  30  KPDIS=I+1
      DO 3 J=KPDIS,NS
      IF(LCUT-KV(J))33,5,33
  33  IF(KCUT-KV(J))3,6,3
  5   LSV=LSV+1
      GO TO 3
  6   LSE=LSE+1
  3   CONTINUE
      KMARK=0
  31  CONTINUE
      LV(I)=KSV
      LVB(I)=LSV
      LE(I)=KSE
      LEB(I)=LSE
      KT=LV(I)+LE(I)+LVB(I)+LEB(I)
      XKT=KT
      KTT=LE(I)+LEB(I)
      XKE=KTT
      Z(I)=(XKE/XKT)*100.0
      GO TO 10
  12  CONTINUE
      DO 64 J=1,5
      K=J
      AA=Z(J)
      AB=Y(J)
      LA=LV(J)
      LB=LE(J)
      LC=LVB(J)
       LD=LEB(J)
      DO 63 I=J,NSS
      IF(Z(I).GE.AA)GO TO 63
      K=I
      AA=Z(I)
      AB=Y(I)
      LA=LV(I)
      LB=LE(I)
      LC=LVB(I)
      LD=LEB(I)
  63  CONTINUE
      Z(K)=Z(J)
      Z(J)=AA
      Y(K)=Y(J)
      Y(J)=AB
      LV(K)=LV(J)
      LV(J)=LA
      LE(K)=LE(J)
      LE(J)=LB
      LVB(K)=LVB(J)
      LVB(J)=LC
      LEB(K)=LEB(J)
      LEB(J)=LD
  64  CONTINUE
      J=1
      DO 123 I=2,5
      IF(Z(1)-Z(I))123,124,123
  124 J=J+1
  123 CONTINUE
      XMID=0.0
      DO 125 I=1,J
      XMID=XMID+Y(I)
      XFIT=FLOAT(LV(I))*FLOAT(LVB(I))
      YFIT=FLOAT(LE(I))*FLOAT(LEB(I))
      AFIT=FLOAT(LV(I))+FLOAT(LEB(I))
      BFIT=FLOAT(LVB(I))+FLOAT(LE(I))
      IF(AFIT.EQ.0.0.OR.BFIT.EQ.0.0)WK(I)=0.0
      IF(AFIT.EQ.0.0.OR.BFIT.EQ.0.0)GO TO 125
      WK(I)=(XFIT-YFIT)/(AFIT*BFIT)
  125 CONTINUE
      XMID=XMID/FLOAT(J)
      AA=Z(1)
      AB=Y(1)
      AC=WK(1)
      LA=LV(1)
      LB=LE(1)
      LC=LVB(1)
      LD=LEB(1)
      IF(J.EQ.1)GO TO 127
      DO 126 I=2,J
      IF(WK(I).LE.AC)GO TO 126
      AA=Z(I)
      AB=Y(I)
      AC=WK(I)
      LA=LV(I)
      LB=LE(I)
      LC=LVB(I)
      LD=LEB(I)
  126 CONTINUE
  127 JSAVE=J
      KPP=AMIN0(KYES,KNO)
      JKK=LB+LD
      XPRE=FLOAT(KPP-JKK)/FLOAT(KPP)
      NOWRIT=1
      IF(NOWRIT.EQ.1)GO TO 888
      IF(JJJJ.EQ.1.AND.III.EQ.1)WRITE(JP,200)
      IF(III.EQ.1)WRITE(JP,250)JJJJ,KAV(JJJJ),KYES,KNO,AB,JSAVE,LA,LC,
     CLB,LD,AA,XPRE,SUMY,SUMN,SUMM
      IF(III.EQ.2)WRITE(JP,260)AB,JSAVE,LA,LC,LB,LD,AA,XPRE
  888 IF(III.EQ.2)GO TO 999
      SAB=AB
      SXPRE=XPRE
  999 CONTINUE
      YPRE=AMAX1(SXPRE,XPRE)
      IF(YPRE.EQ.XPRE)KFLIP=2
      IF(YPRE.EQ.XPRE)ZSAB=AB
      IF(YPRE.EQ.SXPRE)KFLIP=1
      IF(YPRE.EQ.SXPRE)ZSAB=SAB
      RETURN
      END

      SUBROUTINE CPUTIM(KTIM1)
      COMMON /XIME/ NTIME(20),NITR,MSEC
C
      call gettim(itim1,itim2,itim3,itim4)
      mmsec=itim1*60*60+itim2*60+itim3
      KTIM1=mmsec-msec
      RETURN
      END
C
C *******************************************************************
C
C   START-SUBROUTINE TO GET STARTING VALUES 
C
C *******************************************************************
C
      SUBROUTINE START
      dimension xdem(389),xrep(389),npty(389),KPAC(500,500),
     clrep(400),ldem(400),COORD(400),SCOORD(400),UCUT2(500),
     CNUMB(500)
      character*1 knrep(500,10),kndem(500,10),knpac(25),KNAM2,KNAME
      COMMON /XXCOM/ ZMID(1601),XDATA(513),DYN(1601),ldata(501,601),
     CUCUTI(501),UCUTC(501),XINC(1601)
      COMMON /BOOK/ BBB(50)
      COMMON /MINE/ NS,NQ,NRCALL,NSTEP,NEQ,ISENS(1000),
     CJAN,JANLST,JIO,KIO,NOBS,NOPAR,IFDRV,NFEVAL,
     CMAXIT,MAXSQZ,KNOL,KSTRT
      COMMON /VOTES/ KAV(1601),kay(1601),kan(1601),kname(513,25),
     CKNAM2(500,25),jne
   30 format(1X,i4,1x,i5,1x,25A1,f7.3)
   40 format(4x,500i3)
 1250 format(1x,25a1,4x,500i2)
 1260 format(51x,25a1)
 1280 format(1x,i4,3f7.3)
  300 format(6i8)
  305 format(5i7,2f7.3)
  310 format(1x,i4,2f7.3)
  420 FORMAT(1X,I4,1X,3F7.3)
      i = 0
      id = 0
      ir = 0
   90 read(25,30,end=89)numb(I+1),npty(i+1),(knam2(I+1,j),j=1,25),
     CCOORD(i+1)
      WRITE(*,30)numb(I+1),npty(i+1),(knam2(I+1,j),j=1,25),
     CCOORD(i+1)
      i=i+1
      go to 90
   89 CONTINUE
      AA=(COORD(1)+COORD(NRCALL))/2.0
      BB=COORD(NRCALL)-AA
      DO 66 I=1,NRCALL
      COORD(I)=(COORD(I)-AA)/BB
      XINC(I)=COORD(I)
   66 CONTINUE
      DO 67 I=1,NRCALL
      if(npty(i).eq.1)then
           id=id+1
           xdem(id)=coord(i)
           ldem(id)=numb(I)
           do 42 j=1,10
  42       kndem(id,j)=knam2(I,j)
      endif
      if(npty(i).eq.2)then
           ir=ir+1
           xrep(ir)=coord(i)
           lrep(ir)=numb(I)
           do 43 j=1,10
  43       knrep(ir,j)=knam2(I,j)
      endif
  67  CONTINUE
      id=int(id/2)
      ir=int(ir/2)  
      lj = 0
      do 150 l = 1,NRCALL
      if(npty(l).ne.1)go to 150
      lj = lj + 1
      lq = ldem(lj)
      zmid(lq) = .5*(xdem(lj)+xrep(ir))
      DYN(lq) = .5*(xrep(ir)-xdem(lj))
  150 continue
      lk = 0
      do 160 ll=1,NRCALL
      if(npty(ll).ne.2)go to 160
      lk=lk+1          
      lr = lrep(lk)
      zmid(lr) = .5*(xrep(lk)+xdem(id))
      DYN(lr) = .5*(xdem(id)-xrep(lk))
  160 continue 
    1 continue
      DO 260 I=1,NOBS
      BETA=BBB(1)
      WTSQ=.5*BBB(2)*BBB(2)
      KEXL=0
      KEXR=0
      IDD=0
      DO 270 KK = 1,NRCALL
      IF(LDATA(I,KK).EQ.1)THEN
         IDD=IDD+1
         SCOORD(IDD)=COORD(KK)
      ENDIF
  270 CONTINUE
      IT=INT(IDD/2)
      XDATA(I)=SCOORD(IT)
      UCUTI(I)=WTSQ*(XDATA(I)-SCOORD(IDD))**2
      UCUT2(I)=WTSQ*(XDATA(I)-SCOORD(1))**2
      UCUTI(I)=BETA*EXP(-UCUTI(I))
      UCUT2(I)=BETA*EXP(-UCUT2(I))
      UCUTI(I)=.5*(UCUTI(I)+UCUT2(I))
      UCUTC(I)=beta
  260 CONTINUE
      NSTEP=2
      NOPAR=3
      DO 171 KSTRT=1
      call MAXLIK
  171 continue
      RETURN
      END 